Package: MCbiclust
Type: Package
Title: Massive correlating biclusters for gene expression data and
        associated methods
Version: 1.35.0
Date: 2024-02-02
Author: Robert Bentham
Maintainer: Robert Bentham <robert.bentham.11@ucl.ac.uk>
Description: Custom made algorithm and associated methods for finding,
        visualising and analysing biclusters in large gene expression
        data sets. Algorithm is based on with a supplied gene set of
        size n, finding the maximum strength correlation matrix
        containing m samples from the data set.
Depends: R (>= 3.4)
Imports: BiocParallel, graphics, utils, stats, AnnotationDbi, GO.db,
        org.Hs.eg.db, GGally, ggplot2, scales, cluster, WGCNA
Suggests: gplots, knitr, rmarkdown, BiocStyle, gProfileR, MASS, dplyr,
        pander, devtools, testthat, GSVA
License: GPL-2
biocViews: ImmunoOncology, Clustering, Microarray, StatisticalMethod,
        Software, RNASeq, GeneExpression
RoxygenNote: 6.0.1
VignetteBuilder: knitr
LazyData: true
git_url: https://git.bioconductor.org/packages/MCbiclust
git_branch: devel
git_last_commit: 538a41b
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: no
Packaged: 2025-10-31 22:39:23 UTC; biocbuild

# MCbiclust

MCbiclust is a R package for running massively correlating biclustering analysis. MCbiclust aims to find large scale biclusters with selected features being highly correlated with each other over a subset of samples.

The package was originally designed as part of my PhD at UCL, in order to solve a problem in bioinformatics: to find biclusters representing different modes of regulation of mitochondria gene expression in disease states such as breast cancer.
The same methods however, can be used on any gene expression data set to find biclusters of interest.

## ----results = "hide",warning = FALSE, message=FALSE--------------------------
library(MCbiclust)

## ----results = "hide",warning = FALSE,message=FALSE---------------------------
library(ggplot2)
library(gplots)
library(dplyr)
library(gProfileR)
library(MASS)
library(devtools)

## -----------------------------------------------------------------------------
data(CCLE_small)
data(Mitochondrial_genes)

## -----------------------------------------------------------------------------
mito.loc <- which(row.names(CCLE_small) %in% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

## ----results='hide', eval=FALSE-----------------------------------------------
# set.seed(102)
# CCLE.seed <- FindSeed(gem = CCLE.mito,
#                       seed.size = 10,
#                       iterations = 10000,
#                       messages = 1000)

## ----results='hide', eval=TRUE, echo=FALSE------------------------------------
CCLE.seed <- MCbiclust:::Vignette_seed

## -----------------------------------------------------------------------------
set.seed(103)
random.seed <- sample(seq(length = dim(CCLE.mito)[2]), 10)
CorScoreCalc(CCLE.mito,random.seed)
CorScoreCalc(CCLE.mito,CCLE.seed)

## ----dev='png'----------------------------------------------------------------
CCLE.random.cor <- cor(t(CCLE.mito[,random.seed]))
heatmap.2(CCLE.random.cor,trace = "none")

## ----dev='png'----------------------------------------------------------------
CCLE.mito.cor <- cor(t(CCLE.mito[,CCLE.seed]))
heatmap.2(CCLE.mito.cor,trace = "none")

## ----dev='png'----------------------------------------------------------------
CCLE.hicor.genes <- as.numeric(HclustGenesHiCor(CCLE.mito,
                                                CCLE.seed,
                                                cuts = 8))
CCLE.mito.cor2 <- cor(t(CCLE.mito[CCLE.hicor.genes, CCLE.seed]))
CCLE.heat <- heatmap.2(CCLE.mito.cor2,trace = "none")

## -----------------------------------------------------------------------------
CCLE.groups <- list(labels(CCLE.heat$rowDendrogram[[1]]),
                    labels(CCLE.heat$rowDendrogram[[2]]))

## -----------------------------------------------------------------------------
CCLE.cor.vec <- CVEval(gem.part = CCLE.mito,
                        gem.all = CCLE_small,
                        seed = CCLE.seed, splits = 10)

## ----results='hide', eval=FALSE-----------------------------------------------
# GSE.MW <- GOEnrichmentAnalysis(gene.names = row.names(CCLE_small),
#                                gene.values = CCLE.cor.vec,
#                                sig.rate = 0.05)

## ----results='hide', eval=TRUE, echo=FALSE------------------------------------
GSE.MW <- MCbiclust:::Vignette_GSE

## ----results = "asis"---------------------------------------------------------
row.names(GSE.MW) <- NULL
pander::pandoc.table(GSE.MW[1:10,],row.names = FALSE)

## ----results = "asis"---------------------------------------------------------
top200 <- row.names(CCLE_small)[order(CCLE.cor.vec,
                                             decreasing = TRUE)[seq(200)]]

# top200.gprof <- gprofiler(top200)
# dim(top200.gprof)

## ----results = "asis"---------------------------------------------------------
# pander::pandoc.table(top200.gprof[seq(10),-c(1,2,7,8,11,14)],
#                     row.names = FALSE)

## ----results='hide', eval=FALSE-----------------------------------------------
# CCLE.samp.sort <- SampleSort(CCLE.mito[as.numeric(CCLE.hicor.genes),],
#                              seed = CCLE.seed)

## ----results='hide', eval=TRUE, echo=FALSE------------------------------------
CCLE.samp.sort <- MCbiclust:::Vignette_sort[[1]]

## -----------------------------------------------------------------------------
top.mat <- CCLE.mito[as.numeric(CCLE.hicor.genes),]

pc1.vec <- PC1VecFun(top.gem = top.mat,
                     seed.sort = CCLE.samp.sort, n = 10)

## -----------------------------------------------------------------------------
CCLE.bic <- ThresholdBic(cor.vec = CCLE.cor.vec,
                         sort.order = CCLE.samp.sort,
                         pc1 = pc1.vec, samp.sig = 0.05)

## -----------------------------------------------------------------------------
pc1.vec <- PC1Align(gem = CCLE_small, pc1 = pc1.vec,
                    sort.order = CCLE.samp.sort,
                    cor.vec = CCLE.cor.vec, bic = CCLE.bic)


## -----------------------------------------------------------------------------
av.genes.group1 <- colMeans(CCLE.mito[CCLE.groups[[1]],
                                      CCLE.samp.sort])
av.genes.group2 <- colMeans(CCLE.mito[CCLE.groups[[2]],
                                      CCLE.samp.sort])

## -----------------------------------------------------------------------------

CCLE.names <- colnames(CCLE_small)[CCLE.samp.sort]
fork.status <- ForkClassifier(pc1.vec, samp.num = length(CCLE.bic[[2]]))

CCLE.df <- data.frame(CCLE.name = CCLE.names,
                      PC1 = pc1.vec,
                      Fork = fork.status,
                      Average.Group1 = av.genes.group1,
                      Average.Group2 = av.genes.group2,
                      Order = seq(length = length(pc1.vec)))

ggplot(CCLE.df, aes(Order,PC1)) +
  geom_point(aes(colour = Fork)) + ylab("PC1")

ggplot(CCLE.df, aes(Order,Average.Group1)) +
  geom_point(aes(colour = Fork)) + ylab("Average Group 1")

ggplot(CCLE.df, aes(Order,Average.Group2)) +
  geom_point(aes(colour = Fork)) + ylab("Average Group 2")

## -----------------------------------------------------------------------------
data(CCLE_samples)

## -----------------------------------------------------------------------------
CCLE.samples.names <- as.character(CCLE_samples[,1])
CCLE.samples.names[c(1:15)] <- paste("X",CCLE.samples.names[c(1:15)],
                                     sep="")
CCLE_samples$CCLE.name <- CCLE.samples.names

## -----------------------------------------------------------------------------

rownames(CCLE_samples) <- as.character(CCLE_samples[,1])

CCLE.data.names <- colnames(CCLE_small)
CCLE_small_samples <- CCLE_samples[CCLE.data.names,]


## ----warning=FALSE,message=FALSE----------------------------------------------
CCLE.df.samples <- inner_join(CCLE.df,CCLE_samples,by="CCLE.name")

ggplot(CCLE.df.samples, aes(Order,PC1)) +
  geom_point(aes(colour=factor(Site.Primary))) + ylab("PC1")

## -----------------------------------------------------------------------------
rare.sites <- names(which(summary(CCLE.df.samples$Site.Primary) < 15))
CCLE.df.samples$Site.Primary2 <- as.character(CCLE.df.samples$Site.Primary)

rare.sites.loc <- which(CCLE.df.samples$Site.Primary2 %in% rare.sites)
CCLE.df.samples$Site.Primary2[rare.sites.loc] <- "Other"

ggplot(CCLE.df.samples, aes(Order,PC1)) +
  geom_point(aes(colour=factor(Site.Primary2))) + ylab("PC1")

## ----warning=FALSE,message=FALSE----------------------------------------------
ggplot(CCLE.df.samples, aes(Order,PC1)) +
  geom_point(aes(colour=factor(Gender))) + ylab("PC1")

## -----------------------------------------------------------------------------
library(MASS)

# create contingency tables
ctable.site <- table(CCLE.df.samples$Fork,
                     CCLE.df.samples$Site.Primary)

ctable.gender <- table(CCLE.df.samples$Fork,
                       CCLE.df.samples$Gender,
                       exclude = "U")

chisq.test(ctable.site)
chisq.test(ctable.gender)

## ----results='hide', message=FALSE, eval=FALSE--------------------------------
# CCLE.multi.seed <- list()
# initial.seed1 <- list()
# 
# for(i in seq(100)){
#   set.seed(i)
#   initial.seed1[[i]] <- sample(seq(length = dim(CCLE_small)[2]),10)
#   CCLE.multi.seed[[i]] <- FindSeed(gem = CCLE_small[c(501:1000), ],
#                                    seed.size = 10,
#                                    iterations = 500,
#                                    initial.seed = initial.seed1[[i]])
# }

## ----results='hide', eval=TRUE, echo=FALSE------------------------------------
CCLE.multi.seed <- MCbiclust:::Vignette_multi_seed
initial.seed1 <- MCbiclust:::Vignette_initial_seed

## ----results='hide', message=FALSE, eval=FALSE--------------------------------
# CCLE.cor.vec.multi <- list()
# 
# for(i in seq(100)){
#   CCLE.cor.vec.multi[[i]] <- CVEval(gem.part = CCLE_small[c(501:1000), ],
#                                     gem.all = CCLE_small,
#                                     seed = CCLE.multi.seed[[i]],
#                                     splits = 10)
# 
# }

## ----results='hide', eval=TRUE, echo=FALSE------------------------------------
CCLE.cor.vec.multi <- MCbiclust:::Vignette_multi_cv

## -----------------------------------------------------------------------------
len.a <- length(CCLE.cor.vec.multi[[1]])
len.b <- length(CCLE.cor.vec.multi)
multi.run.cor.vec.mat <- matrix(0,len.a,len.b)
for(i in 1:100){
  multi.run.cor.vec.mat[,i] <- CCLE.cor.vec.multi[[i]]
}
rm(CCLE.cor.vec.multi)


## ----dev='png'----------------------------------------------------------------
CV.cor.mat1 <- abs(cor((multi.run.cor.vec.mat)))
cor.dist <- function(c){as.dist(1 - abs(c))}

routput.corvec.matrix.cor.heat <- heatmap.2(CV.cor.mat1,
                                            trace="none",
                                            distfun = cor.dist)

## -----------------------------------------------------------------------------
multi.clust.groups <- SilhouetteClustGroups(multi.run.cor.vec.mat,
                                            max.clusters = 20,
                                            plots = TRUE,rand.vec = FALSE)

## ----dev='png'----------------------------------------------------------------
gene.names <- row.names(CCLE_small)
av.corvec.fun <- function(x) rowMeans(multi.run.cor.vec.mat[,x])
average.corvec <- lapply(X = multi.clust.groups,
                         FUN = av.corvec.fun)

CVPlot(cv.df = as.data.frame(average.corvec),
        geneset.loc = mito.loc,
        geneset.name = "Mitochondrial",
        alpha1 = 0.1)

## -----------------------------------------------------------------------------
GOfun <- function(x) GOEnrichmentAnalysis(gene.names = gene.names,
                                          gene.values = x,
                                          sig.rate = 0.05)

## ----results='hide', message=FALSE, eval=FALSE--------------------------------
# corvec.gsea <- lapply(X = average.corvec,
#                       FUN = GOfun)

## ----results='hide', eval=TRUE, echo=FALSE------------------------------------
corvec.gsea <- MCbiclust:::Vignette_multi_gsea

## -----------------------------------------------------------------------------
CCLE.samp.multi.sort <- list()
multi.prep <- MultiSampleSortPrep(gem = CCLE_small,
                                  av.corvec = average.corvec,
                                  top.genes.num = 750,
                                  groups = multi.clust.groups,
                                  initial.seeds =  CCLE.multi.seed)


## ----eval=FALSE---------------------------------------------------------------
# CCLE.samp.multi.sort[[1]] <- SampleSort(gem = multi.prep[[1]][[1]],
#                                         seed = multi.prep[[2]][[1]])
# 
# CCLE.samp.multi.sort[[2]] <- SampleSort(gem = multi.prep[[1]][[2]],
#                                         seed = multi.prep[[2]][[2]])

## ----results='hide', echo=FALSE-----------------------------------------------
CCLE.samp.multi.sort <- list()
CCLE.samp.multi.sort[[1]] <- MCbiclust:::Vignette_sort[[2]][[1]]
CCLE.samp.multi.sort[[2]] <- MCbiclust:::Vignette_sort[[2]][[2]]

## -----------------------------------------------------------------------------
pc1.vec.multi <- list()
 
pc1.vec.multi[[1]] <- PC1VecFun(top.gem =  multi.prep[[1]][[1]],
                     seed.sort = CCLE.samp.multi.sort[[1]], n = 10)
pc1.vec.multi[[2]] <- PC1VecFun(top.gem =  multi.prep[[1]][[2]],
                     seed.sort = CCLE.samp.multi.sort[[2]], n = 10)

## -----------------------------------------------------------------------------
CCLE.bic.multi <- list()
CCLE.bic.multi[[1]] <- ThresholdBic(cor.vec = average.corvec[[1]],
                         sort.order = CCLE.samp.multi.sort[[1]],
                         pc1 = pc1.vec.multi[[1]], samp.sig = 0.05)
CCLE.bic.multi[[2]] <- ThresholdBic(cor.vec = average.corvec[[2]],
                         sort.order = CCLE.samp.multi.sort[[2]],
                         pc1 = pc1.vec.multi[[2]], samp.sig = 0.05)


pc1.vec.multi[[1]] <- PC1Align(gem = CCLE_small, pc1 = pc1.vec.multi[[1]],
                    sort.order = CCLE.samp.multi.sort[[1]],
                    cor.vec = average.corvec[[1]], bic = CCLE.bic.multi[[1]])

pc1.vec.multi[[2]] <- PC1Align(gem = CCLE_small, pc1 = pc1.vec.multi[[2]],
                    sort.order = CCLE.samp.multi.sort[[2]],
                    cor.vec = average.corvec[[2]], bic = CCLE.bic.multi[[2]])

## -----------------------------------------------------------------------------
CCLE.multi.df <- data.frame(CCLE.name = colnames(CCLE_small),
           Bic1.order = order(CCLE.samp.multi.sort[[1]]),
           Bic2.order = order(CCLE.samp.multi.sort[[2]]),
           Bic1.PC1 = pc1.vec.multi[[1]][order(CCLE.samp.multi.sort[[1]])],
           Bic2.PC1 = pc1.vec.multi[[2]][order(CCLE.samp.multi.sort[[2]])])

CCLE.multi.df.samples <- inner_join(CCLE.multi.df,CCLE_samples,by="CCLE.name")

rare.sites <- names(which(summary(CCLE.multi.df.samples$Site.Primary) < 15))
CCLE.multi.df.samples$Site.Primary2 <- as.character(CCLE.multi.df.samples$Site.Primary)

rare.sites.loc <- which(CCLE.multi.df.samples$Site.Primary2 %in% rare.sites)
CCLE.multi.df.samples $Site.Primary2[rare.sites.loc] <- "Other"

ggplot(CCLE.multi.df.samples, aes(Bic1.order,Bic1.PC1)) +
  geom_point(aes(colour=factor(Site.Primary2))) + ylab("Bic1 PC1")

ggplot(CCLE.multi.df.samples, aes(Bic2.order,Bic2.PC1)) +
  geom_point(aes(colour=factor(Site.Primary2))) + ylab("Bic2 PC1")


## ----dev="png"----------------------------------------------------------------
cv.df <- as.data.frame(average.corvec)
cv.df$Mito1 <- CCLE.cor.vec

CVPlot(cv.df,cnames = c("R1","R2","M1"),
        geneset.loc = mito.loc,
        geneset.name = "Mitochondrial",
        alpha1 = 0.1)


## -----------------------------------------------------------------------------
gene.loc1 <- which(row.names(CCLE.mito[CCLE.hicor.genes,]) %in% CCLE.groups[[1]])
gene.loc2 <- which(row.names(CCLE.mito[CCLE.hicor.genes,]) %in% CCLE.groups[[2]])

CCLE.ps <- PointScoreCalc(CCLE.mito[CCLE.hicor.genes,], gene.loc1, gene.loc2)

## ----dev="png"----------------------------------------------------------------
CCLE.df$PointScore <- CCLE.ps[CCLE.samp.sort]

ggplot(CCLE.df, aes(Order,PC1)) +
  geom_point(aes(colour = Fork)) + ylab("PC1")
ggplot(CCLE.df, aes(Order,PointScore)) +
  geom_point(aes(colour = Fork)) + ylab("PointScore")


## -----------------------------------------------------------------------------
# library(GSVA)
# 
# ssGSEA.test <- gsva(expr = as.matrix(CCLE.mito[CCLE.hicor.genes,]),
#                     gset.idx.list = CCLE.groups,
#                     method = 'gsva',
#                     parallel.sz = 1)
# ssGSEA.test[2,] <- -ssGSEA.test[2,]
# CCLE.ssGSEA <- colMeans(ssGSEA.test)


## ----dev="png"----------------------------------------------------------------
# CCLE.df$ssGSEA <- CCLE.ssGSEA[CCLE.samp.sort]
# 
# ggplot(CCLE.df, aes(Order, PC1)) +
#   geom_point(aes(colour = Fork)) + ylab("PC1")
# ggplot(CCLE.df, aes(Order, ssGSEA)) +
#   geom_point(aes(colour = Fork)) + ylab("ssGSEA")


## ----session_info, include=TRUE, echo=TRUE, results='markup'------------------
devtools::session_info()

#' Find highly correlated seed of samples for gene expression matrix
#' 
#' \code{FindSeed()} is the key function in MCbiclust. It takes a gene expression
#' matrix and by a stochastic method greedily searches for a seed of samples
#' that maximizes the correlation score of the chosen gene set.
#' 
#' Additional options allow for the search to start at a chosen seed, for instance
#' if a improvement to a known seed is desired. The result of \code{FindSeed()} is 
#' dependent on the number of iterations, with above 1000 usually providing a good
#' seed, and above 10000 an optimum seed.
#' 
#' @param gem Gene expression matrix with genes as rows and samples as columns
#' @param seed.size Size of sample seed
#' @param iterations Number of iterations
#' @param initial.seed Initial seed used, if NULL randomly chosen
#' @param messages frequency of progress messages
#' @return Highly correlated seed
#' @example example_code/example_corscore.R
#' @export

FindSeed <- function (gem, seed.size, iterations,
                      initial.seed = NULL, messages = 100){
  
    message("Iteration\tCorrelation Score")
    sample.list <- list()
    sample.size <- dim(gem)[2]
    if (length(initial.seed) == seed.size){
        seed <- initial.seed
    } else {
        seed <- sample(seq_len(sample.size), seed.size)
    }
    gem.t <- t(gem)
    zero.rows <- (apply(X = gem[, seed],MARGIN = 1,FUN = sd) == 0)

    if (sum(zero.rows,na.rm = TRUE) != 0) {
        test.cor <- cor(gem.t[seed, !zero.rows], use = 'pairwise.complete.obs')
    }
    else {
        test.cor <- cor(gem.t[seed, ], use = 'pairwise.complete.obs')
    }
    test.cor.score <- mean(abs(test.cor),na.rm = TRUE)
  
    rv <- sample(seq_len(seed.size), iterations, replace = TRUE)
  
    for (i in seq_len(iterations)) {
        seed2 <- seed[-rv[i]]
        avoid.samples <- seed2
        seed2 <- c(seed2, sample(seq_len(sample.size)[-avoid.samples],1))
        zero.rows <- (apply(X = gem[, seed2],MARGIN = 1,FUN = sd) == 0)
        if (sum(zero.rows,na.rm = TRUE) != 0) {
            test.cor <- cor(gem.t[seed2, !zero.rows], use = 'pairwise.complete.obs')
        }
        else {
            test.cor <- cor(gem.t[seed2, ], use = 'pairwise.complete.obs')
        }
        test.cor.score2 <- mean(abs(test.cor),na.rm = TRUE)
        if (test.cor.score2 > test.cor.score) {
            taken.out <- rv[i]
            if(taken.out == 1){
                seed <- c(seed2[seed.size], seed[-1])
            } else if(taken.out == seed.size){
                  seed <- c(seed[-seed.size], seed2[seed.size])
            } else{
                  pre.replace <- seq_len(taken.out-1)
                  post.replace <- seq_len(seed.size)[-seq_len(taken.out)]
                  seed <- c(seed[pre.replace],seed2[seed.size],
                            seed[post.replace])
                  }
            test.cor.score <- test.cor.score2
           
        }
        if (i%%messages == 0) {
            message(paste(i,"\t\t",format(test.cor.score,digits = 5)))
        }
    }

    return(seed)
}

#' Calculate correlation score
#' 
#' The standard method to calculate the correlation score used to judge biclusters
#' in MCbiclust
#' 
#' @param gene.expr.matrix Gene expression matrix with genes as rows and samples as columns
#' @param sample.vec Vector of samples
#' @return The correlation score
#' @example example_code/example_corscore.R
#' @export

#' @export
#' @rdname CorScoreCalc

CorScoreCalc <- function(gene.expr.matrix,sample.vec){
      a <- abs(cor(t(gene.expr.matrix[,sample.vec]), use = 'pairwise.complete.obs'))
      return(sum(a,na.rm = TRUE)/length(a))
}


CorScoreCalc_t <- function(gene.expr.matrix,sample.vec){
  a <- abs(cor((gene.expr.matrix[sample.vec,]), use = 'pairwise.complete.obs'))
  return(sum(a,na.rm = TRUE)/length(a))
}

data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- (row.names(CCLE_small) %in% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

set.seed(102)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 1000)

CCLE.sort <- SampleSort(gem = CCLE.mito,seed = CCLE.seed,sort.length = 11)

# Full ordering are in Vignette_sort in sysdata.rda
CCLE.samp.sort <- MCbiclust:::Vignette_sort[[1]]

CCLE.pc1 <- PC1VecFun(top.gem = CCLE.mito,
                      seed.sort = CCLE.samp.sort,
                      n = 10)

CCLE.cor.vec <-  CVEval(gem.part = CCLE.mito,
                            gem.all = CCLE_small,
                            seed = CCLE.seed,
                            splits = 10)

CCLE.bic <- ThresholdBic(cor.vec = CCLE.cor.vec,sort.order = CCLE.samp.sort,
                         pc1 = as.numeric(CCLE.pc1))

CCLE.pc1 <- PC1Align(gem = CCLE_small, pc1 = CCLE.pc1,
                     cor.vec = CCLE.cor.vec ,
                     sort.order = CCLE.samp.sort,
                     bic =CCLE.bic)

CCLE.fork <- ForkClassifier(CCLE.pc1, samp.num = length(CCLE.bic[[2]]))

#' MCbiclust: Massively Correlated biclustering
#'
#' MCbiclust is a R package for running massively correlating biclustering
#' analysis.MCbiclust aims to find large scale biclusters with selected 
#' features being highly correlated with each other over a subset of samples.
#'
#' The package was originally designed in order to solve a problem in
#' bioinformatics: to find biclusters representing different modes of regulation
#' of mitochondria gene expression in disease states such as breast cancer. 
#' The same methods however, can be used on any gene expression data set to
#' find biclusters of interest.
#'
#' To learn more about MCbiclust, start with the vignette:
#' \code{browseVignettes(package = "MCbiclust")}
#' @docType package
#' @name MCbiclust
#' @importFrom stats hclust kmeans sd p.adjust cutree dist as.dendrogram wilcox.test prcomp lsfit rnorm as.dist median quantile
#' @importFrom BiocParallel bplapply MulticoreParam bpstart bpstop SnowParam
#' @importFrom graphics plot
#' @importFrom utils combn
#' @importFrom GO.db GO.db
#' @importFrom org.Hs.eg.db org.Hs.egSYMBOL
#' @importFrom AnnotationDbi select mget
#' @importFrom GGally ggpairs putPlot
#' @importFrom ggplot2 ggplot theme geom_density geom_point xlab ylab aes_
#' @importFrom scales hue_pal
#' @importFrom cluster silhouette
#' @importFrom WGCNA cor
#' @importMethodsFrom AnnotationDbi as.list

NULL

#' Calculate gene set enrichment of correlation vector using Mann-Whitney test
#' 
#' The Mann-Whitney test is typically used due to the values of the correlation
#'  vector, not being normally distributed. \code{GOEnrichmentAnalysis} provides 
#'  an interface  with the GO database annotation to find the most significant GO
#'  terms.
#' 
#' @param gene.names Names of the genes in standard gene name format.
#' @param gene.values Values associated with the genes, e.g the correlation vector
#'  output of \code{CVEval}. 
#' @param sig.rate Level of significance required after multiple hypothesis
#'  adjustment.
#' @return Data frame of the significant gene sets, with GOID, GO Term, number
#'  of genes, number of genes in GO Term, number of genes in GO Term also in
#'  gene set, adjusted p-value, average value of correlation vector in gene set
#'  and phenotype describing whether average value of correlation vector is
#'  above or below the total average.
#' @example example_code/example_GOEnrichment.R
#' @name GOEnrichmentAnalysis

NULL

#' @export
#' @rdname GOEnrichmentAnalysis


GOEnrichmentAnalysis <- function(gene.names,gene.values,sig.rate){
    GO.data <-GoDataLoad()
  
    GO_term_matrix <- GO.data[[1]]
    GO_term_genes <- GO.data[[2]]

    pvalues <- MannWhitneyGOTerms(gene.names,gene.values,GO_term_genes)
    adj.pvalues <- p.adjust(pvalues)

    GenelistNum <- function(y){
        return(sum(gene.names %in% y, na.rm = TRUE))
    }
    GenelistLoc <- function(y){
        return(gene.names %in% y)
    }
    GenelistMean <- function(y){
        return(mean(gene.values[y]))
    }
    sig.p <- which((adj.pvalues) < sig.rate)
    ordering.p <- order(adj.pvalues[sig.p])
    num.genes <- as.numeric(unlist(lapply(GO_term_genes[sig.p],
                                          length)))[ordering.p]
    g.in.genelist <- as.numeric(lapply(GO_term_genes[sig.p],
                                       GenelistNum))[ordering.p]
    CV.av.value <- as.numeric(lapply(lapply(GO_term_genes[sig.p],GenelistLoc),
                                     GenelistMean))[ordering.p]
    p.value <- pvalues[sig.p][ordering.p]
    adj.p.value <- adj.pvalues[sig.p][ordering.p]
  
    av.gene.values <- mean(gene.values)
  
    phenofun <- function(x) return(ifelse(CV.av.value[x] > 
                                            av.gene.values,1,-1))
    phenotype <- vapply(seq_len(length(sig.p)),FUN = phenofun,FUN.VALUE = numeric(1))
  
    return(cbind(GO_term_matrix[sig.p[ordering.p],], num.genes,
                 g.in.genelist, adj.p.value, CV.av.value, phenotype))

}

# Runs Mann-Whitney test for all GO terms
MannWhitneyGOTerms <- function(genes, gene.values,GO_term_genes){
  
  mannfun1 <- function(x){
    a <- (genes %in% GO_term_genes[[x]])
    if(sum(a,na.rm = TRUE) > 10){
      return(wilcox.test(gene.values[a],
                         gene.values)$p.value)
    }else{
      return(NA)
    }}
  
  go.pvalues <- vapply(seq_len(length(GO_term_genes)), FUN = mannfun1, FUN.VALUE = numeric(1))
  return((go.pvalues))
}

# Load data for Gene set enrichment analysis
GoDataLoad <- function(){
  xx <- as.list(org.Hs.eg.db::org.Hs.egGO2ALLEGS)
  GO_term_list <- names(xx)
  GO_term_matrix <- AnnotationDbi::select(GO.db::GO.db, GO_term_list, c("TERM","ONTOLOGY"))
  
  GO_gene_get<-function(y){
    return(as.character(unlist(mget(y,org.Hs.egSYMBOL))))}
  
  GO_term_genes<-lapply(X=xx,GO_gene_get)
  
  return(list(GO_term_matrix, GO_term_genes))
}

#' Slihouette validation of correlation vector clusters 
#' 
#' MCbiclust is a stochastic method and needs to be run multiple times to 
#' identify different biclusters. \code{SilhouetteClustGroups()} examines
#' the correlation vectors calculated from different runs and uses the
#' technique of examining silhouette widths to identify the number of distinct
#' clusters (and hence biclusters) found.
#' 
#' @param cor.vec.mat Correlation matrix of the correlation vectors (CVs)
#' @param max.clusters Maximum number of clusters to divide CVs into
#' @param plots True or False for whether to show silhouette plots
#' @param seed1 Value used to set random seed
#' @param rand.vec True or False for whether to add random correlation vector used for comparison
#' @return The distinct clusters of correlation vectors
#' @example example_code/example_sil.R
#' @export


SilhouetteClustGroups <- function(cor.vec.mat, max.clusters,
                                  plots = FALSE, seed1 = 100,
                                  rand.vec = TRUE){
  
    if(max.clusters >= dim(cor.vec.mat)[2]){
        max.clusters <- dim(cor.vec.mat)[2] - 1
    }
  
    if(rand.vec == TRUE){
        set.seed(seed1)
        cor.vec.mat.len <- dim(cor.vec.mat)[1]
        cor.vec.mat.add <- dim(cor.vec.mat)[2] + 1
        cor.vec.mat2 <- cbind(cor.vec.mat, rnorm(cor.vec.mat.len, 0))
    }else{
        cor.vec.mat2 <- cor.vec.mat
    }
  
    cor.dist <- as.dist(1 - abs(cor(cor.vec.mat2,use = 'pairwise.complete.obs')))
    cor.hclust <- hclust(cor.dist)
  
    silfun1 <- function(x){
        si2 <- silhouette(x = cutree(cor.hclust,k = x),dist = cor.dist)
        return(mean(si2[,3]))
    }
  
    sil.value <- vapply(seq_len(max.clusters)[-1], FUN = silfun1,FUN.VALUE = numeric(1))
  
    if(plots == TRUE) print(plot(seq_len(max.clusters-1)+1,
                                 sil.value, xlab="Number of clusters",
                                 ylab="Mean silhoette width"))
  
    k1 <- which.max(sil.value) + 1
    si2 <- silhouette(x = cutree(cor.hclust,k = k1), dist = cor.dist)
  
    if(plots == TRUE) print(plot(si2,col="red",main=""))
  
    cluster.groups <- lapply(seq_len(k1),
                             FUN=function(x) (cutree(cor.hclust,
                                                          k = k1) == x))
  
    if(rand.vec == TRUE){
        cor.vec.minus.fun <- function(x){
            return(sum(all(x==c(rep(FALSE,dim(cor.vec.mat)[2]), TRUE)),na.rm = TRUE))}
        cor.vec.minus <- unlist(lapply(cluster.groups,
                                             FUN = cor.vec.minus.fun)) == 1
        cluster.groups <- cluster.groups[!(cor.vec.minus)]
        cluster.groups <- lapply(cluster.groups,
                                 FUN = function(x) x[seq_len(dim(cor.vec.mat)[2])])
    }
    return(cluster.groups)
}

data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- (row.names(CCLE_small) %in% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

set.seed(101)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 100)

CCLE.cor.vec <- CVEval(gem.part = CCLE.mito,
                       gem.all = CCLE_small,
                       seed = CCLE.seed, splits = 10)

# Significant GO terms can be calculated as follows:
# GEA <- GOEnrichmentAnalysis(gene.names = row.names(CCLE_small),
#                            gene.values = CCLE.cor.vec,
#                            sig.rate = 0.05)

data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- which(row.names(CCLE_small) %in% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

random.seed <- sample(seq(length = dim(CCLE.mito)[2]),10)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 100)


CorScoreCalc(CCLE.mito, random.seed)
CorScoreCalc(CCLE.mito, CCLE.seed)

CCLE.hicor.genes <- as.numeric(HclustGenesHiCor(CCLE.mito,
                                                CCLE.seed,
                                                cuts = 8))

CorScoreCalc(CCLE.mito[CCLE.hicor.genes,], CCLE.seed)

#' Make correlation vector plot
#' 
#' A function to visualise the differences between different found biclusters. 
#' Output is a matrix of plots. Each correlation vector is plotted against each 
#' other across the entire  measured gene set in the lower diagonal plots, and
#' a chosen gene set (e.g. mitochondrial) in the upper diagonal plots. The diagnal
#' plots themselves show the density plots of the entire measured and chosen
#' gene set. There are addition options to set the transparancy of the data
#' points and names of the correlation vectors.
#' 
#' @param cv.df A dataframe containing the correlation vectors of one or more patterns.
#' @param geneset.loc A gene set of interest (e.g. mitochondrial) to be plotted separately from rest of genes.
#' @param geneset.name Name of geneset (e.g. mitochondrial genes)
#' @param alpha1 Transparency level of non-gene set genes
#' @param alpha2 Transparency level of gene set genes
#' @param cnames Character vector containing names for the correlation vector
#' @return A plot of the correlation vectors
#' @example example_code/example_cvplot.R
#' @export

CVPlot <- function (cv.df, geneset.loc, geneset.name, alpha1 = 0.005, alpha2 = 0.1, 
          cnames = NULL) 
{
  if (is.character(geneset.name) == FALSE) {
    stop("geneset.name must be a single character value")
  }
  cv.num <- dim(cv.df)[2]
  if (length(cnames) != cv.num) {
    colnames(cv.df)[seq_len(cv.num)] <- paste(rep("CV", cv.num), 
                                              seq_len(cv.num), sep = "")
  }
  else {
    colnames(cv.df) <- cnames
  }
  mito_status <- rep(paste("Non", geneset.name), dim(cv.df)[1])
  mito_status[geneset.loc] <- geneset.name
  cv.df$Status <- mito_status
  status.loc <- (colnames(cv.df) == "Status")
  if (dim(cv.df)[2] == 2) {
    a1 <- colnames(cv.df)[1]
    a2 <- "Status"
    p <- ggplot(cv.df, aes_(x = as.name(a1), col = as.name(a2))) + 
      xlab(a1)
    return(p + geom_density())
  }
  custom_cv_plot <- ggpairs(cv.df[, !status.loc], upper = "blank", 
                            lower = "blank", title = "", axisLabels = "show")
  col_cv <- hue_pal(h = c(0, 360) + 15, c = 100, l = 65, h.start = 0, 
                    direction = 1)(2)
  H_plot_fun <- function(a, b) {
    a1 <- colnames(cv.df)[a]
    b1 <- colnames(cv.df)[b]
    p <- ggplot(cv.df[-geneset.loc, ], aes_(x = as.name(a1), 
                                            y = as.name(b1))) + xlab(a1) + ylab(b1)
    return(p + geom_point(size = 2, alpha = alpha1, col = col_cv[2]))
  }
  H_combn <- combn(cv.num, 2)
  H_plot_fun2 <- function(i) {
    p1 <- H_plot_fun(H_combn[1, i], H_combn[2, i])
    return(p1)
  }
  p_H_plots <- lapply(seq_len(dim(H_combn)[2]), H_plot_fun2)
  for (i in seq_len(dim(H_combn)[2])) {
    custom_cv_plot <- putPlot(custom_cv_plot, p_H_plots[[i]], 
                              H_combn[2, i], H_combn[1, i])
  }
  H_m_plot_fun <- function(a, b) {
    a1 <- colnames(cv.df)[a]
    b1 <- colnames(cv.df)[b]
    p <- ggplot(cv.df[geneset.loc, ], aes_(x = as.name(a1), 
                                           y = as.name(b1))) + xlab(a1) + ylab(b1)
    return(p + geom_point(size = 2, alpha = alpha2, col = col_cv[1]))
  }
  H_m_plot_fun2 <- function(i) {
    p1 <- H_m_plot_fun(H_combn[1, i], H_combn[2, i])
    return(p1)
  }
  p_mH_plots <- lapply(seq_len(dim(H_combn)[2]), H_m_plot_fun2)
  for (i in seq_len(dim(H_combn)[2])) {
    custom_cv_plot <- putPlot(custom_cv_plot, p_mH_plots[[i]], 
                              H_combn[1, i], H_combn[2, i])
  }
  H_d_plot_fun <- function(a, l1 = FALSE) {
    a1 <- colnames(cv.df)[a]
    a2 <- "Status"
    p <- ggplot(cv.df, aes_(x = as.name(a1), col = as.name(a2))) + 
      xlab(a1)
    if (l1 == FALSE) {
      return(p + geom_density() + theme(legend.position = "none"))
    }
    else {
      return(p + geom_density())
    }
  }
  for (i in seq_len(cv.num - 1)) {
    custom_cv_plot <- putPlot(custom_cv_plot, H_d_plot_fun(i), 
                              i, i)
  }
  custom_cv_plot <- putPlot(custom_cv_plot, H_d_plot_fun(cv.num, 
                                                         l1 = FALSE), cv.num, cv.num)
  return(custom_cv_plot)
}

data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- (row.names(CCLE_small) %in% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

CCLE.seed <- list()
CCLE.cor.vec <- list()

for(i in 1:5){
    set.seed(i)
    CCLE.seed[[i]] <- FindSeed(gem = CCLE.mito,
                               seed.size = 10,
                               iterations = 100,
                               messages = 100)}

for(i in 1:5){
  CCLE.cor.vec[[i]] <-  CVEval(gem.part = CCLE.mito,
                               gem.all = CCLE_small,
                               seed = CCLE.seed[[i]],
                               splits = 10)}

CCLE.cor.mat <- as.matrix(as.data.frame(CCLE.cor.vec))

CCLE.clust.groups <- SilhouetteClustGroups(cor.vec.mat = CCLE.cor.mat,
                                           plots = TRUE,
                                           max.clusters = 10)

av.corvec.fun <- function(x) rowMeans(CCLE.cor.mat[,x])
CCLE.average.corvec <- lapply(X = CCLE.clust.groups,
                              FUN = av.corvec.fun)

multi.sort.prep <- MultiSampleSortPrep(gem = CCLE_small,
                                       av.corvec = CCLE.average.corvec,
                                       top.genes.num = 750,
                                       groups =CCLE.clust.groups,
                                       initial.seeds = CCLE.seed)  

multi.sort <- list()        
for(i in seq_len(length(CCLE.clust.groups))){
    multi.sort[[i]] <- SampleSort(multi.sort.prep[[1]][[i]],
                                  seed = multi.sort.prep[[2]][[i]],
                                  sort.length = 11)
}

#' Methods for ordering samples
#' 
#' After finding an initial bicluster with \code{FindSeed()} the next step is
#' to extend the bicluster by ordering the remaining samples by how they 
#' preserve the correlation found.
#' 
#' \code{SampleSort()} is the basic function that achieves this, it takes the
#' gene expression matrix, seed of samples, and also has options for the number
#' of cores to run the method on and the number of samples to sort.
#' 
#' \code{MultiSampleSortPrep()} is a preparation function for \code{SampleSort()}
#' when MCbiclust has been run multiple times and returns a list of gene expression
#' matrices and seeds for each `distinct` bicluster found.
#' 
#' @param gem Gene expression matrix with genes as rows and samples as columns
#' @param seed Sample seed of highly correlating genes
#' @param num.cores Number of cores used in parallel evaluation
#' @param sort.length Number of samples to be sorted
#' @param av.corvec List of average correlation vector 
#' @param top.genes.num Number of the top genes in correlation vector to use for sorting samples
#' @param groups List showing what runs belong to which correlation vector group
#' @param initial.seeds List of sample seeds from all runs
#' @return Order of samples by strength to correlation pattern
#' @example example_code/example_pc1.R
#' @name SampleSort

NULL

#' @export
#' @rdname SampleSort

SampleSort <- function(gem,seed,num.cores = 1,sort.length = NULL){
    message("Sort Length \t Cor Score")
    
    gem_t <- t(gem)
  
    seed1 <- seed
    sample.size <- dim(gem)[2]
    if(length(sort.length) == 0){
        order.size <- sample.size 
    }
    else{
        order.size <- sort.length
    }
  
    seq.vec <- seq_len(order.size - length(seed))  
    tcv.max <- seq_len(length(seq.vec) + 1)
    tcv.max[1] <- CorScoreCalc_t(gem_t, seed)
    temp.fun1 <- function(x) CorScoreCalc_t(gem_t,x)
    
    if(length(num.cores)==0){
      param = bpstart(SnowParam())
    }else{
      param = bpstart(SnowParam(workers = num.cores))
    }
    
    for(j in seq.vec){
        next.seed <- seq_len(sample.size)[-seed1]
        len1 <- length(next.seed)
        multi.core.list <- lapply(seq_len(len1), function(x)c(seed1,
                                                                   next.seed[x]))
  
        test.cor.values <- unlist(bplapply(multi.core.list, FUN=temp.fun1,
                                           BPPARAM = param))

        tcv.max[j + 1] <- max(test.cor.values)
        seed1 <- c(seed1, next.seed[which(test.cor.values==tcv.max[j + 1])[1]])
        if(length(seed1) %% 10 == 0){
            message(paste(length(seed1),"\t\t", format(tcv.max[j+1],digits = 3)))}
        }  
    bpstop(param)
    return(seed1)
}


#' @export
#' @rdname SampleSort
MultiSampleSortPrep <- function(gem, av.corvec, top.genes.num,
                                groups, initial.seeds){
  
  t.fun <- function(x){
    return(order(abs(x),decreasing = TRUE)[seq_len(top.genes.num)])
  }
  
  top.genes <- lapply(X = av.corvec,
                      FUN = t.fun)
  
  top.seed.score <- lapply(groups,
                           FUN = function(x) seq_len(length(x)))
  
  top.seed.fun1 <- function(y) vapply(seq_len(sum(groups[[y]],na.rm = TRUE)),
                                      FUN = function(x){
                                        l1 <- top.genes[[y]]
                                        a <- groups[[y]]
                                        l2 <- initial.seeds[a][[x]]
                                        b <- as.matrix(gem)[l1,l2]
                                        return(mean(abs(cor(t(b)))))
                                      }, FUN.VALUE = numeric(1))
  
  top.seed.score <- lapply(seq_len(length(groups)),FUN = top.seed.fun1)
  
  
  t.fun2 <- function(x){
    a <- initial.seeds[groups[[x]]][[which.max(top.seed.score[[x]])[1]]]
    return(a)
  }
  top.seed <- lapply(seq_len(length(av.corvec)),
                     FUN = t.fun2)
  top.mat <- lapply(top.genes, FUN = function(x) as.matrix(gem)[x,])
  
  return(list(top.mat, top.seed))
}

#' Calculate PointScore
#' 
#' Using two gene sets that are represented of a known bicluster (one gene set being 
#' up regulated while other gene set is down regulated), samples are scored based
#' on how well they match the known regulation of the bicluster.
#' 
#' The PointScore of a sample can be directly compared to the PC1 value. The PointScore
#' is typically used to identify samples related to the upper/lower fork  of a bicluster
#' without running the complete main MCbiclust pipeline on a dataset.
#' 
#' @param gene.expr.matrix Gene expression matrix with genes as rows and samples as columns
#' @param gene.loc1 Location of the rows containing the genes in gene set 1 within the gene expression matrix
#' @param gene.loc2 Location of the rows containing the genes in gene set 2 within the gene expression matrix
#' @return Vector of point scores for each sample in the gene expression matrix
#' @example example_code/example_pointscore.R
#' @export

PointScoreCalc <- function(gene.expr.matrix, gene.loc1, gene.loc2){
  if(dim(gene.expr.matrix)[2] == 1 || class(gene.expr.matrix) == 'numeric'){
    stop('Error: PointScoreCalc is not a single sample method')
  }
  if(dim(gene.expr.matrix)[2] <= 10){
    warning('PointScoreCalc is being run with very few samples. \n Method relies on the calculation of median value of each gene so results may not be accurate')
  }
  
  gem1 <- gene.expr.matrix - apply(gene.expr.matrix, MARGIN = 1, median, na.rm = TRUE)
  samp.len <- dim(gem1)[2]
  
  ps.vec <- rep(0, samp.len)
  
  for(i in seq(length = samp.len)){
    for(j in seq(length = length(gene.loc1))){
      if(is.na(gem1[gene.loc1[j], i])){
        next
      }
      if(gem1[gene.loc1[j], i] > 0){
        ps.vec[i] <- ps.vec[i] + 1
      } else{
        ps.vec[i] <- ps.vec[i] - 1
      }
    }
    for(k in seq(length = length(gene.loc2))){
      if(gem1[gene.loc2[k], i] > 0){
        ps.vec[i] <- ps.vec[i] - 1
      } else{
        ps.vec[i] <- ps.vec[i] + 1
      }
    }
  }
  return(ps.vec)
}

#' Find the most highly correlated genes using hierarchical clustering
#' 
#' Upon finding an initial bicluster with \code{FindSeed()} not all the genes
#' in the chosen geneset will be highly correlated to the bicluster. 
#' \code{HclustGenesHiCor()} uses the output of \code{FindSeed()} and 
#' hierarchical clustering to only select the genes that are most highly correlated
#' to the bicluster. This is achieved by cutting the dendogram produced
#' from the clustering into a set number of groups and then only selecting the
#' groups that are most highly correlated to the bicluster
#' 
#' @param gem Gene expression matrix with genes as rows and samples as columns
#' @param seed Seed of highly correlating samples
#' @param cuts Number of groups to cut dendogram into
#' @return Numeric vector of most highly correlated genes
#' @example example_code/example_corscore.R
#' @export

HclustGenesHiCor <- function(gem,seed,cuts){
  
    row.names(gem) <- seq_len(dim(gem)[1])
  
    gem.cor <- cor(t(gem[,seed]),use = 'pairwise.complete.obs')
    
    gem.dend <- as.dendrogram(hclust(dist(gem.cor)))
    gem.hclust <- hclust(dist(gem.cor))
    gem.cuts <- cutree(gem.hclust, k=cuts)
  
    hclust.genes.list <- lapply(seq_len(cuts),
                                function(x) which(gem.cuts == x))
 
    temp.fun <- function(i) CorScoreCalc(data.frame(gem)[hclust.genes.list[[i]],],seed)
    hi.cor.values <- vapply(X=seq_len(cuts),temp.fun, FUN.VALUE = numeric(1))
  
    cor.value <- CorScoreCalc(gem, seed) 
  
    return(unlist(hclust.genes.list[which(hi.cor.values > cor.value)]))
}

data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- which(row.names(CCLE_small) %in% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

CCLE.seed <- list()
CCLE.cor.vec <- list()

for(i in 1:3){
    set.seed(i)
    CCLE.seed[[i]] <- FindSeed(gem = CCLE.mito,
                               seed.size = 10,
                               iterations = 100,
                               messages = 100)}

for(i in 1:3){
    CCLE.cor.vec[[i]] <-  CVEval(gem.part = CCLE.mito,
                                 gem.all = CCLE_small,
                                 seed = CCLE.seed[[i]],
                                splits = 10)}



CCLE.cor.df <- (as.data.frame(CCLE.cor.vec))

CVPlot(cv.df = CCLE.cor.df, geneset.loc = mito.loc,
       geneset.name = "Mitochondrial",alpha1 = 0.5)

#' Method for the calculation of a correlation vector
#' 
#' Upon identifying a bicluster seed with \code{FindSeed}, one of the next
#' steps is to identify which genes not in your chosen gene set are also
#' highly correlated to the bicluster found. This is done by \code{CVEval},
#' and the output is known as the correlation vector.
#' 
#' \code{CVeval} uses hierarchical clustering to select the genes most 
#' representative of the bicluster and then uses the average expression of
#' these genes across the sample seed and calculates the correlation of
#' every gene measured across the sample seed to this average expression value.
#' 
#' The correlation vector is the output of this calculation.
#' 
#' 
#' @param gem.part Part of gene expression matrix only containing gene set of interest with genes as rows and samples as columns
#' @param gem.all All of gene expression matrix
#' @param seed Seed of highly correlating samples
#' @param splits Number of cuts from hierarchical clustering
#' @return Correlation vector
#' @example example_code/example_pc1.R
#' @name CVEval

NULL

#' @export
#' @rdname CVEval
CVEval <- function(gem.part, gem.all, seed, splits){
      gene.vec <- GeneVecFun(gem.part, seed, splits)
      dim1 <- dim(gem.all)[1]
      temp.fun <- function(x) return(cor(as.numeric(gem.all[x, seed]), gene.vec,
                                         use = 'pairwise.complete.obs'))
      return(vapply(seq_len(dim1), temp.fun,FUN.VALUE = numeric(1)))
}


# Calcuclates gene vector used in calculation of correlation vector

GeneVecFun <- function(gem,seed,splits){
  
  test.list <- lapply(X = seq_len(splits)[-1],
                      FUN = function(x) GeneVecFunCalc(gem, seed, x))
  
  test4 <- which.max(vapply(test.list,max,
                            FUN.VALUE = numeric(1)))
  test1 <- cutree(hclust(dist(cor(t(gem[,seed]),use = 'pairwise.complete.obs'))),
                  k = (test4 + 1))
  test2 <- lapply(seq_len((test4 + 1)),
                  FUN = function(x) (test1 == x))
  
  temp.fun <- function(x) CorScoreCalc(data.frame(gem)[test2[[x]],],seed) * 
    sqrt(sum(test2[[x]],na.rm = TRUE))
  
  test3 <- vapply(seq_len((test4 + 1)), FUN = temp.fun, FUN.VALUE = numeric(1))
  test5 <- test2[[which.max(test3)]]
  return(colMeans(gem[test5,seed]))
}

# Function needed for gene vector calculation

GeneVecFunCalc <- function(gem,seed,n){
  test1 <- cutree(hclust(dist(cor(t(gem[,seed]),use = 'pairwise.complete.obs'))),k = n)
  test2 <- lapply(seq_len(n),FUN = function(x) (test1 == x))
  temp.fun <- function(x) CorScoreCalc(data.frame(gem)[test2[[x]],],seed) * 
    sqrt(sum(test2[[x]],na.rm = TRUE))
  test3 <- vapply(seq_len(n), FUN = temp.fun, FUN.VALUE = numeric(1))
  return(test3)
}

#' Calculate PC1 vector of found pattern
#' 
#' The correlations found between the chosen geneset in a subset of samples
#' can be summarised by looking at the first principal component (PC1) 
#' using principal coponent analysis (PCA).
#' 
#' \code{PC1VecFun()} takes a gene expression matrix and the sample ordering
#' and fits a PC1 value to all the samples based on a PCA analysis done on
#' the first n samples.
#' 
#' @param top.gem Gene expression matrix containing only highly correlating genes
#' @param seed.sort Ordering of samples according to strength of correlation
#' @param n Number of samples to use in calculation of PC1
#' @return PC1 value for each sample
#' @example example_code/example_pc1.R
#' @export


PC1VecFun <- function(top.gem,seed.sort,n){
    pca.matrix <- top.gem[,seed.sort[seq_len(n)]]
    pca.results <- prcomp(t(pca.matrix),center=TRUE)
    pca.loadings <- pca.results$rotation
  
    hi.cor.matrix <- top.gem[,seed.sort]
  
    pc1fun1 <- function(x){
        return(lsfit(as.matrix(pca.loadings),
                     as.matrix(hi.cor.matrix[,x]))$coef[2])}
  
    pc1.vec <- vapply(seq_len(length(seed.sort)), FUN = pc1fun1, FUN.VALUE = numeric(1))
  
    return(pc1.vec)
}

#' Clinical information for CCLE data
#'
#' A dataset containing clinical information for the CCLE samples. 
#'
#' @format A data frame with 967 rows and 14 variables:
#' \itemize{
#'   \item CCLE.name: Sample name identifier.
#'   \item Cell.line.primary.name: Cell line name.
#'   \item Cell.line.aliases: Any known aliases of cell line.
#'   \item Gender: Gender of patient cell line derived from.
#'   \item Site.Primary: Primary site cell line derived from.
#'   \item Histology: Histology of tumour cell line derived from.
#'   \item Hist.Subtype1: Histology subtype of tumour cell line derived from.
#'   \item Notes: Additional notes.
#'   \item Source: Source of the cell line.
#'   \item Expression.arrays: Expression array used.
#'   \item SNP.arrays: SNP array used.
#'   \item Oncomap: Oncomap mutation array used.
#'   \item Hybrid.Capture.Sequencing: Hybrid capture sequencing used.
#'   \item Name: Sample name identifier
#' }
#' @source \url{http://www.broadinstitute.org/ccle/data/browseData} Filename: CCLE_sample_info_file_2012-04-06.txt 
#' @return NA
"CCLE_samples"


#' Subset of expression levels of CCLE data
#'
#' A dataset containing the gene-centric RMA-normalized mRNA expression data for nearly 1000 genes and 500 samples taken as a random subset of the complete CCLE data. 
#' 1000 genes were selected randomly such that 500 were mitochondrial and 500 non-mitochondrial.
#'
#' @format A data frame with 1000 rows and 500 variables:
#' \itemize{
#'   \item MKN74_STOMACH: mRNA expression on sample MKN74_STOMACH
#'   \item OC316_OVARY: mRNA expressionr on sample OC316_OVARY
#'   \item ...
#' }
#'  @source \url{http://www.broadinstitute.org/ccle/data/browseData} Filename: CCLE_Expression_Entrez_2012-04-06.gct.gz
#' @return NA
"CCLE_small"


#' List of known mitochondrial genes
#'
#' A dataset from MitoCarta1.0 containing the 1023 mitochondrial genes
#' Availiable from the broad institute: http://www.broadinstitute.org/scientific-community/science/programs/metabolic-disease-program/publications/mitocarta/mitocarta-in-0
#'
#' @format A Character vector of the HGNC approved gene names
#' @source \url{https://www.broadinstitute.org/publications/broad807s} 
#' @return NA
"Mitochondrial_genes"

#' Methods for defining a bicluster
#'
#' A bicluster is the fundamental result found using MCbiclust. These
#' three functions are essential for the precise definition of these
#' biclusters.
#' 
#' \code{ThresholdBic()} takes as its main inputs the correlation vector 
#' (output of \code{CVEval()}), sample ordering (output of
#' \code{SampleSort()}), PC1 vector (output of \code{PC1VecFun}) and returns
#' a list of the genes and samples which belong to the bicluster according 
#' to a certain level of significance.
#' 
#' \code{PC1Align()} is a function used once the bicluster has been found to
#' ensure that the upper fork samples (those with higher PC1 values) correspond
#' to those samples that have genes with positive correlation vector values
#'up-regulated.
#' 
#' \code{ForkClassifier()} is a function used to classify which samples are in
#' the upper or lower fork.
#'  
#'
#' @param gem Gene expression matrix containing genes as rows and samples as columns.
#' @param cor.vec Correlation vector (output of \code{CVEval()}).
#' @param sort.order Order of samples (output of \code{SampleSort()}).
#' @param pc1 PC1 values for samples (output of \code{PC1VecFun}).
#' @param samp.sig Value between 0 and 1 determining number of samples in bicluster
#' @param bic bicluster (output of \code{ThresholdBic()})
#' @param samp.num Number of samples in the bicluster
#' @return Defined bicluster
#' @example example_code/example_pc1.R
#' @name ThresholdBic

NULL

#' @export
#' @rdname ThresholdBic

ThresholdBic <- function(cor.vec,sort.order,pc1,samp.sig = 0){
  
    cor.vec.kmeans <- kmeans(abs(cor.vec),centers = 2)
    genes.group1.loc <- (cor.vec.kmeans$cluster == 1)
    genes.group2.loc <- (cor.vec.kmeans$cluster == 2)
  
    if(mean(abs(cor.vec)[genes.group1.loc]) > 
       mean(abs(cor.vec)[genes.group2.loc])){
        bic.genes <- genes.group1.loc
    }else{
        bic.genes <- genes.group2.loc
    }
  
    pc1.min <- quantile(rev(pc1)[seq_len(ceiling(length(pc1) / 10))],
                        probs = 0 + (samp.sig/2))
    pc1.max <- quantile(rev(pc1)[seq_len(ceiling(length(pc1) / 10))],
                        probs = 1 - (samp.sig/2))
    first.no.samp <- which(pc1 > pc1.min & pc1 < pc1.max)[1]
  
    if(length(first.no.samp) > 0){
        bic.samps <- sort.order[seq_len(first.no.samp -1)]
    }else{
        bic.samps <- NA
    }

    return(list(bic.genes, bic.samps))
}


#' @export
#' @rdname ThresholdBic
PC1Align <- function(gem, pc1, cor.vec, sort.order, bic){
  
  max.cv.loc <- which.max(cor.vec)
  number.samps <- seq_len(max(3, length(bic[[2]])))
  gem1 <- gem[max.cv.loc, sort.order[number.samps]]
  cor.test <- cor(as.numeric(gem1), pc1[number.samps])
  
  if(cor.test < 0){
    pc1 <- -pc1
  }
  return(pc1)
}


#' @export
#' @rdname ThresholdBic
ForkClassifier <- function(pc1,samp.num){
  k.run1 <- kmeans(pc1[seq_len(samp.num)],2)
  g1 <- (k.run1[[1]] == 1)
  g2 <- (k.run1[[1]] == 2)
  if(mean(pc1[g1]) > mean(pc1[g2])){
    group1 <- g1
    group2 <- g2
  }else{
    group1 <- g2
    group2 <- g1
  }
  fork.status <- rep("None",length(pc1))
  fork.status[seq_len(samp.num)][group1] <- "Upper"
  fork.status[seq_len(samp.num)][group2] <- "Lower"
  
  return(fork.status)}

data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- which(row.names(CCLE_small) %in% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

suppressWarnings(RNGversion("3.5.0")) 
set.seed(101)
CCLE.seed <- FindSeed(gem = CCLE.mito,seed.size = 10,
                      iterations = 100,messages = 50)

CCLE.sort <- SampleSort(gem = CCLE.mito,seed = CCLE.seed,sort.length = 11)

CCLE.samp.sort <- MCbiclust:::Vignette_sort[[1]]

CCLE.pc1 <- PC1VecFun(top.gem = CCLE.mito,
                      seed.sort = CCLE.samp.sort,
                      n = 10)

CCLE.hicor.genes <- as.numeric(HclustGenesHiCor(CCLE.mito,
                                                CCLE.seed,
                                                cuts = 8))

CCLE.cor.mat <- cor(t(CCLE.mito[CCLE.hicor.genes,CCLE.seed]))

gene.set1 <- labels(as.dendrogram(hclust(dist(CCLE.cor.mat)))[[1]])
gene.set2 <- labels(as.dendrogram(hclust(dist(CCLE.cor.mat)))[[2]])

gene.set1.loc <- which(row.names(CCLE.mito) %in% gene.set1)
gene.set2.loc <- which(row.names(CCLE.mito) %in% gene.set2)

CCLE.ps <- PointScoreCalc(CCLE.mito,gene.set1.loc,gene.set2.loc)

test_that('PointScoreCalc returns error and warnings in right situation',{
  expect_error(PointScoreCalc(CCLE.mito[,1],gene.set1.loc,gene.set2.loc))
  expect_error(PointScoreCalc(CCLE.mito[,1],gene.set1.loc,gene.set2.loc))
  expect_warning(PointScoreCalc(CCLE.mito[,seq_len(10)],gene.set1.loc,gene.set2.loc))
}
)

CCLE.mito[gene.set1.loc,1][10] <- NA 

test_that("HclustGenesHiCor and CVEval work with matrices",{
  expect_error(as.numeric(HclustGenesHiCor(as.matrix(CCLE.mito),
                                                CCLE.seed,
                                                cuts = 58)), NA)
  
  expect_error(CVEval(gem.part = as.matrix(CCLE.mito),
         gem.all = as.matrix(CCLE_small),
         seed = CCLE.seed,
         splits = 58), NA)
  
})

test_that("PC1VecFun returns as expected",{
  expect_equal(length(CCLE.pc1), 500)
})

CCLE.cor.vec <-  CVEval(gem.part = CCLE.mito,
                        gem.all = CCLE_small,
                        seed = CCLE.seed,
                        splits = 10)

CCLE.bic <- ThresholdBic(cor.vec = CCLE.cor.vec,sort.order = CCLE.samp.sort,
                         pc1 = as.numeric(CCLE.pc1))

CCLE.pc1 <- PC1Align(gem = CCLE_small, pc1 = CCLE.pc1,
                     cor.vec = CCLE.cor.vec ,
                     sort.order = CCLE.samp.sort,
                     bic =CCLE.bic)

CCLE.fork <- ForkClassifier(CCLE.pc1, samp.num = length(CCLE.bic[[2]]))

test_that("Basic functioning remains constant",{
  expect_equal_to_reference(CCLE.seed,"ccle_seed.rds")
  expect_equal_to_reference(CCLE.sort,"ccle_sort.rds")
  expect_equal_to_reference(CCLE.cor.vec,"ccle_cv.rds")
  expect_equal_to_reference(CCLE.bic,"ccle_bic.rds")
  #expect_equal_to_reference(CCLE.pc1,"ccle_pc1.rds")
  expect_equal_to_reference(CCLE.fork,"ccle_fork.rds")
  expect_equal_to_reference(CCLE.ps,"ccle_ps.rds")
})

CCLE.mito[gene.set1.loc,1][10] <- NA 
test_that("PointScoreCalc handles NA values",{
  expect_error(PointScoreCalc(CCLE.mito[,seq_len(11)],gene.set1.loc,gene.set2.loc),
               NA)
})

test_that("FindSeed returns as expected",{
  expect_equal(length(CCLE.seed), 10)
  expect_message(FindSeed(gem = CCLE.mito,seed.size = 10,
                          iterations = 100,messages = 50),"Iteration")
  expect_error(FindSeed(gem = CCLE.mito,seed.size = 501,
                        iterations = 100,messages = 50))
})

test_that("SampleSort returns as expected",{
  expect_equal(length(CCLE.sort), 11)
})

test_that("CVEval returns as expected",{
  expect_equal(length(CCLE.cor.vec), 1000)
})

test_that("ThresholdBic returns as expected",{
  expect_equal(length(CCLE.bic), 2)
  expect_equal(length(CCLE.bic[[1]]), 1000)
  expect_equal(length(CCLE.bic[[2]]), 58)
})

test_that("PC1Align returns as expected",{
  expect_equal(length(CCLE.pc1), 500)
})


CCLE.bic[[2]] <- CCLE.bic[[2]][1]

test_that("PC1Align works with bicluster with single sample",{
  expect_error(PC1Align(gem = CCLE_small, pc1 = CCLE.pc1,
                        cor.vec = CCLE.cor.vec ,
                        sort.order = CCLE.samp.sort,
                        bic =CCLE.bic), NA)
          }
          )

          

data(CCLE_data)
data(Mitochondrial_genes)

CCLE.data <- CCLE_data[,-c(1,2)]
mito.loc <- which(as.character(CCLE_data[,2]) %in% Mitochondrial_genes)
CCLE.mito <- CCLE_data[mito.loc,-c(1,2)]
row.names(CCLE.mito) <- CCLE_data[mito.loc,2]

set.seed(101)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 100)

CCLE.cor.vec <- CVEval(gem.part = CCLE.mito,
                       gem.all = CCLE.data,
                       seed = CCLE.seed, splits = 10)

GEA <- GOEnrichmentAnalysis(gene.names = CCLE_data[,2],
                            gene.values = CCLE.cor.vec,
                            sig.rate = 0.05)

---
title: "Introduction to MCbiclust"
author: 
 - name: "Robert Bentham"
   affiliation: "Cell and Developmental Biology, University College London"
   email: "robert.bentham.11@ucl.ac.uk"
date: "2018-06-04"
output: 
  BiocStyle::html_document:
    toc_float: true
vignette: >
  %\VignetteIndexEntry{Introduction to MCbiclust}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
abstract: MCbiclust is a R package for running massively correlating biclustering analysis. MCbiclust aims to find large scale biclusters with selected features being highly correlated with each other over a subset of samples. MCbiclust was particularly designed for the application of studying gene expression data, finding and understanding biclusters that are related to large scale co-regulation of genes.
package: |
  MCbiclust 1.3.3
  Report issues on https://github.com/rbentham/MCbiclust/issues
bibliography: bibvignette.bib
---

# Introduction
MCbiclust is a R package for running massively correlating biclustering analysis. MCbiclust aims to find large scale biclusters with selected features being highly correlated with each other over a subset of samples. MCbiclust was particularly designed for the application of studying gene expression data, finding and understanding biclusters that are related to large scale co-regulation of genes.

Report issues on https://github.com/rbentham/MCbiclust/issues

# Getting started
Once installed MCbiclust can be loaded with the following command:

```{r, results = "hide",warning = FALSE, message=FALSE}
library(MCbiclust)
```

MCbiclust also makes sure that the packages BiocParallel, cluster, stats, GGally, ggplot2 and scales are all installed. It is also advised that the packages ggplot2 and gplots are separately installed and loaded.

```{r, results = "hide",warning = FALSE,message=FALSE}
library(ggplot2)
library(gplots)
library(dplyr)
library(gProfileR)
library(MASS)
library(devtools)
```

# Example of a single run
## Loading Cancer Cell Line Encyclopedia (CCLE) and MitoCarta data sets

For this example analysis we will be seeking to find biclusters related to mitochondrial function in the cancer cell line encyclopedia (@barretina2012cancer). For this two datasets are needed, both of which are available on the MCbiclust package. The first in `CCLE_small` that contains a subset of the gene expression values found in the entire CCLE data set (the full dataset is avaliable at https://portals.broadinstitute.org/ccle/home), the second, `Mitochondrial_genes`, is a list of mitochondrial genes that can be found from MitoCarta1.0 (@pagliarini2008mitochondrial).


```{r}
data(CCLE_small)
data(Mitochondrial_genes)
```

It is a simple procedure to create a new matrix `CCLE.mito` only containing the mitochondrial genes. While there are $1023$ known mitochondrial genes, not all of these are measured in `CCLE_data`.

```{r}
mito.loc <- which(row.names(CCLE_small) %in% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]
```

## Finding a bicluster seed

The first step in using MCbiclust is to find a subset of samples that have the most highly correlating genes in the chosen gene expression matrix. This is done by, calculating the associated correlation matrix and then calculating the absolute mean of the correlations, as a correlation score.

Mathematically for a gene expression dataset measuring multiple gene probes across multiple samples, let
\begin{equation}
X = \textrm{Set of all probes,  } Y = \textrm{Set of all samples}
\end{equation}
Then define two subsets of $X$ and $Y$, $I$ and $J$ repectively
 \begin{equation}
I \subset X \textrm{ and  } J \subset Y
\end{equation}
Subsets $I$ and $J$ form a bicluster on sets $X$ and $Y$, and the strength of this bicluster measured is based on measuring the correlations between pairs of probes in set $I$ across all samples in set $J$.
The correlation between a probe $i \in I$ to a probe $k \in I$ across the samples in $J$ is denoted as $C_{i,k}^J$. 
Then the strength of the bicluster is measured as having a score $\alpha$ based on these correlations, defined as:
\begin{equation}
\alpha_I^J= \frac{1}{|I|^2}\sum_{i \in I} \sum_{k \in I} abs(C_{i,k}^J)
\end{equation}
where the function $abs()$ refers to the absolute value. 
In words the score $\alpha$ is the average of the absolute values of the gene-gene correlation matrix for gene-probe set $I$ across the samples in sample set $J$.

A high $\alpha_I^J$ value indicates that the probes in set $I$ are being strongly co-regulated across the samples in set $J$. 
As $\alpha_I^J$ is calculating using the absolute values of $C_{i,k}^J$, these probes could be in either in correlation or anti-correlation with each other.

`MCbiclust` main aim is therefore to find sets of samples and genes that have a high $\alpha_I^J$ value. This is achieved by first finding a small sample "seed" containing relatively few samples but a very high $\alpha_I^J$ value,

This is achieved with function `FindSeed`, initially a random subset of samples is chosen and then at each iteration one sample is removed and replaced and if this results in a higher $\alpha_I^J$ value than this new subset is chosen. In this function the argument `gem` stands for gene expression matrix, `seed.size` indicates the size of the subset of samples that is sought. `iterations` indicates how many iterations of the algorithm to carry out before stopping. In general the higher the iterations the more optimal the solution in terms of maximising the strength of the correlation.

For reproducibility `set.seed` has been used to set R's pseudo-random number generator. It should also be noted that the for `gem` the data matrix can not contain all the genes, since `FindSeed` involves the calculation of correlation matrices which are not computationally efficient to compute if they involve greater than ~1000 genes.

```{r, results='hide', eval=FALSE}
set.seed(102)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 10000,
                      messages = 1000)
```

```{r, results='hide', eval=TRUE, echo=FALSE}
CCLE.seed <- MCbiclust:::Vignette_seed
```

`FindSeed` has one more additional options, `initial.seed` allows the user to specify the initial subsample to be tested, by default the initial sample subset is randomly chosen. 

There is a function `CorScoreCalc` that can calculate the correlation score $\alpha_I^J$ directly, in general however you should not need to use it, unless you wish to manually check the chosen seed is an improvement on one that is randomly generated.

```{r}
set.seed(103)
random.seed <- sample(seq(length = dim(CCLE.mito)[2]), 10)
CorScoreCalc(CCLE.mito,random.seed)
CorScoreCalc(CCLE.mito,CCLE.seed)
```

The results of `FindSeed` can also be visualised by examining the associated correlation matrix, and viewing the result as a heatmap. Again it is easy to see the difference between the random subsample and the one outputted from `FindSeed`.

```{r, dev='png'}
CCLE.random.cor <- cor(t(CCLE.mito[,random.seed]))
heatmap.2(CCLE.random.cor,trace = "none")
```

```{r, dev='png'}
CCLE.mito.cor <- cor(t(CCLE.mito[,CCLE.seed]))
heatmap.2(CCLE.mito.cor,trace = "none")
```

Note that when the genes are represented as the rows in a matrix, that matrix needs to be transposed before the calculation of the correlation matrix. 

`heatmap.2` is a function from the `gplots` R package. 

## Selecting highly correlated genes

As can be clearly seen from the heat map, not all the mitochondrial genes are equally strongly correlated to each other. There is a function in `MCbiclust` which automatically selects those genes that are most strongly associated with the pattern. This function is `HclustGenesHiCor` and it works by using hierarchical clustering to select the genes into n different groups, and then discarding any of these groups that fail to have a correlation score greater than the correlation score from all the genes together.

```{r,dev='png'}
CCLE.hicor.genes <- as.numeric(HclustGenesHiCor(CCLE.mito,
                                                CCLE.seed,
                                                cuts = 8))
CCLE.mito.cor2 <- cor(t(CCLE.mito[CCLE.hicor.genes, CCLE.seed]))
CCLE.heat <- heatmap.2(CCLE.mito.cor2,trace = "none")
```

There are two groups of genes, strongly correlated to themselves and anti-correlated to each other. These can be extracted from the dendrogram:

```{r}
CCLE.groups <- list(labels(CCLE.heat$rowDendrogram[[1]]),
                    labels(CCLE.heat$rowDendrogram[[2]]))
```

## Calculate the correlation vector

In this example a distinct correlation pattern was found. However this was only examined for genes involved in mitochondrial function. Non-mitochondrial genes are likely also involved in this pattern and it is important to identify them.

All genes can be measured by how they match to this pattern by calculating what is called a correlation vector (CV). This is done in two steps:

1. The pattern is summarised  by finding a subset of genes which all strongly correlate with each other, and calculating their average expression value. This is done by clustering the genes using hierarchical clustering and selecting the best group judged by that groups correlation score multiplied by the square root of the number of genes. This multiplication is done to remove the bias of selecting a group containing very few genes.

1. The correlation vector is calculated by finding the correlation of every gene to the average expression value of the chosen best group.

This process is all encapsulated in the function `CVEval` which takes 4 arguements. `gem.part` is the gene expression matrix for the chosen gene set of interest, e.g. mitochondrial genes, `gem.all` is the entire gene expression matrix, `seed` is the output from `FindSeed` and `splits` is the number of groups to split the chosen gene set into in order to select the best group.

```{r}
CCLE.cor.vec <- CVEval(gem.part = CCLE.mito,
                        gem.all = CCLE_small,
                        seed = CCLE.seed, splits = 10)
```

## Gene Set Enrichment

Using the calculated correlation vector, it is a relatively simple task to perform gene set enrichment. This can be done on any platform (e.g. DAVID, gprofiler, etc.) but MCbiclust comes with an inbuilt function for calculating GO enrichment values using the Mann-Whitney non-parametric test.

This is achieved with the `GOEnrichmentAnalysis` function which takes three inputs:

1. `gene.names`: The names of the genes in standard format.

1. `gene.values`: The correlation vector.

1. `sig.rate`: The value below which adjusted p-values are decided to be significant.

The output is a table with 7 columns:

1. `GOID`: ID for GO term.

1. `TERM`: Name of GO term.

1. `num.genes`: Number of genes in GO term.

1. `g.in.genelist`: Number of genes in GO term that were measured in the gene expression matrix.

1. `adj.p.value`: Adjusted p-value from Mann-Whitney test.

1. `CV.av.value`: Average value of CV for genes in GO term.

1. `phenotype`: +1 if `CV.av.value` is greater than the overall CV average, -1 if the `CV.av.value` is less then the overall CV average.

```{r, results='hide', eval=FALSE}
GSE.MW <- GOEnrichmentAnalysis(gene.names = row.names(CCLE_small),
                               gene.values = CCLE.cor.vec,
                               sig.rate = 0.05)
```

```{r, results='hide', eval=TRUE, echo=FALSE}
GSE.MW <- MCbiclust:::Vignette_GSE
```

There are 76 significant terms and the top 10 most significant can be viewed below:

```{r, results = "asis"}
row.names(GSE.MW) <- NULL
pander::pandoc.table(GSE.MW[1:10,],row.names = FALSE)
```

Since `CCLE_small` is half made up of mitochondrial genes and we were seeking for mitochondrial related biclusters it is not surprising that mitochondrial terms dominate the gene set enrichment. If `MCbiclust` was run on the full CCLE gene expression data set it would be expected to see many more significant non-mitochondrial related terms.

An alternative to using the `GOEnrichmentAnalysis` function would be to use a separate gene set enrichment method such as `gprofiler`, this can be done by for instance selecting the top 200 genes with positive CV values:

```{r, results = "asis"}
top200 <- row.names(CCLE_small)[order(CCLE.cor.vec,
                                             decreasing = TRUE)[seq(200)]]

# top200.gprof <- gprofiler(top200)
# dim(top200.gprof)
```

```{r, results = "asis"}
# pander::pandoc.table(top200.gprof[seq(10),-c(1,2,7,8,11,14)],
#                     row.names = FALSE)
```

## Sample ordering

Already all the genes in the data set have had the correlation calculated to the pattern found. One more task that can be readily done is to order the samples according to the strength of correlation. Function `FindSeed` found the initial $n$ samples that had a very strong correlation with the gene set of interest, the $n+1$ sample is to be selected as that sample which best maintains the correlation strength, this process can be simply repeated until all or the desired number of samples are ordered.

`SampleSort` is the function in `MCbiclust` that completes this procedure, it has $4$ main inputs:

1. `gem`: the gene expression matrix with all the samples and the gene set of interest.

1. `seed`: the initial subsample found with `FindSeed`.

1. ` num.cores`: Used for setting the number of cores used in calculation, default value is to use one core.

1. `sort.length`: Sets the number of samples to be ordered.


```{r, results='hide', eval=FALSE}
CCLE.samp.sort <- SampleSort(CCLE.mito[as.numeric(CCLE.hicor.genes),],
                             seed = CCLE.seed)
```

Note as before that these are long calculations, and may take some time.

```{r, results='hide', eval=TRUE, echo=FALSE}
CCLE.samp.sort <- MCbiclust:::Vignette_sort[[1]]
```

Note that SampleSort is a very computationally expensive function and requires time to run. For a large dataset such as the CCLE data it is advisable to either calculate a partial ordering, which can be done with the `sort.length` arguement or submit the job of sorting the samples to a high performance computing facility.

## PCA

Once the samples have been sorted it is possible to summarise the correlation pattern found using principal component analysis (PCA). 

PCA is a method of dimensional reduction, and converts a data set to a new set of variables known as the principal components. These are designed to be completely uncorrelated or orthogonal to each other. In this way the principal components are new variables that capture the correlations between the old variables, and are in fact a linear combination of the old variables. The first principal component (PC1) is calculated as the one that explains the highest variance within the data, the second than is that which has the highest variance but is completely uncorrelated or orthogonal to the previous principal component. In this way additional principal components are calculated until all the variance in the data set is explained.

PC1 captures the highest variance within the data, so if PCA is run on the found bicluster with very strong correlations between the genes, PC1 will be a variable that summarises this correlation. 

`PC1VecFun` is a function that calculates the PC1 values for all sorted samples. It takes three inputs:

1.`top.gem` is the gene expression matrix with only the most highly correlated genes but with all the sample data.

1. `seed.sort` is the sorting of the data samples found with function `SampleSort`

1. `n` is the number of samples used for initially calculating the weighting of PC1. If set to $10$, the first $10$ samples are used to calculate the weighting of PC1 and then the value of PC1 is calculated for all samples in the ordering.

```{r}
top.mat <- CCLE.mito[as.numeric(CCLE.hicor.genes),]

pc1.vec <- PC1VecFun(top.gem = top.mat,
                     seed.sort = CCLE.samp.sort, n = 10)
```

## Thresholding the bicluster and aligning PC1

So far MCbiclust outputs a ranked list of genes and samples. In many cases it is however necessary to determine which genes and samples are within the bicluster and which are not. This is done with the `ThresholdBic` function, which takes $4$ arguements:

1. `cor.vec`: The correlation vector, output of `CVeval`.

1. `sort.order`: The sorted samples, output of `SampleSort`.

1. `pc1`: The PC1 vector, output of `PC1VecFun`

1. `samp.sig`: A numeric value between 0 and 1 that detemines the number of samples in the bicluster.

The genes in the bicluster are determined using kmeans clustering, and dividing the genes into two clusters based on the absolute value of the correlation vector, choosing one correlated and one uncorrelated groups.

The samples are however chosen based on the last 10% of the ranked samples, these samples are assumed to not belong to the bicluster and the first sample with a PC1 value between the $0 + samp.sig/2$ and $1 - samp.sig/2$ quantiles, and every sample after that is not in the bicluster.


```{r}
CCLE.bic <- ThresholdBic(cor.vec = CCLE.cor.vec,
                         sort.order = CCLE.samp.sort,
                         pc1 = pc1.vec, samp.sig = 0.05)
```

Once this thresholded bicluster has been found it is important to properly align the PC1 vector and the correlation vector such that samples with a high PC1 values are those samples with up-regulated genes that have positive CV values. This is not strictly necessary to do, but makes the interpretation of MCbiclust simpler.

This is done with function `PC1Align` which if necessary times the pc1.vec by -1 to ensure that the correlation vector and PC1 vector are "aligned".

```{r}
pc1.vec <- PC1Align(gem = CCLE_small, pc1 = pc1.vec,
                    sort.order = CCLE.samp.sort,
                    cor.vec = CCLE.cor.vec, bic = CCLE.bic)

```

## Alternative to PCA

As an alternative to calculating PC1, the user may want to calculate the average expression value of certain gene sets. This gives a better idea of the type of regulation occurring in the correlation pattern, as an abstract notion of a principal component does not have to be understood.

```{r}
av.genes.group1 <- colMeans(CCLE.mito[CCLE.groups[[1]],
                                      CCLE.samp.sort])
av.genes.group2 <- colMeans(CCLE.mito[CCLE.groups[[2]],
                                      CCLE.samp.sort])
```


## Plotting the forks

Once the samples have been ordered and PC1 and the average gene sets calculated it is a simple procedure to produce plots of these against the ordered samples.

One final additional thing that can be done is to classify the samples into belonging to the bicluster or not, and additionally whether a sample belongs to the Upper or Lower fork. This can be done with the function `ForkClassifier`

To produce the plots of the forks the `ggplot2` package is used.

```{r }

CCLE.names <- colnames(CCLE_small)[CCLE.samp.sort]
fork.status <- ForkClassifier(pc1.vec, samp.num = length(CCLE.bic[[2]]))

CCLE.df <- data.frame(CCLE.name = CCLE.names,
                      PC1 = pc1.vec,
                      Fork = fork.status,
                      Average.Group1 = av.genes.group1,
                      Average.Group2 = av.genes.group2,
                      Order = seq(length = length(pc1.vec)))

ggplot(CCLE.df, aes(Order,PC1)) +
  geom_point(aes(colour = Fork)) + ylab("PC1")

ggplot(CCLE.df, aes(Order,Average.Group1)) +
  geom_point(aes(colour = Fork)) + ylab("Average Group 1")

ggplot(CCLE.df, aes(Order,Average.Group2)) +
  geom_point(aes(colour = Fork)) + ylab("Average Group 2")
```

This by itself however is not particularly enlightening and to get additional information out of these plots supplementary information needs to be examined.

## Comparing results with sample data

This section will deal with an addition data sets both of which are available in the MCbiclust package.

* CCLE sample information, a data set containing information for every sample in the data set, including gender of the patient the cell line was derived from, as well as the primary site it came from.

This section is meant as an example of the type of analysis that can be done with additional data set. Each new data set may have different additional data available with it and may be in formats that need some extra work to become compatible with the results from the `MCbiclust` analysis. 

### CCLE sample data

This data set is available within the `MCbiclust` package.

```{r }
data(CCLE_samples)
```

In this case some samples have an additional "X" not present in some CCLE_samples data so it is necessary to add it for consistency.

```{r }
CCLE.samples.names <- as.character(CCLE_samples[,1])
CCLE.samples.names[c(1:15)] <- paste("X",CCLE.samples.names[c(1:15)],
                                     sep="")
CCLE_samples$CCLE.name <- CCLE.samples.names
```

The first step is to compare the column names of both data sets and to make sure we are dealing with the same correctly labeled samples.

```{r }

rownames(CCLE_samples) <- as.character(CCLE_samples[,1])

CCLE.data.names <- colnames(CCLE_small)
CCLE_small_samples <- CCLE_samples[CCLE.data.names,]

```


Using the `dplyr` library, it is possible to join this new data set to the one we made for plotting the values of PC1 in the previous section. This can be easily done as both datasets share a column - the name of the samples. Once this is done, it is again simple to produce additional plots.

```{r, warning=FALSE,message=FALSE }
CCLE.df.samples <- inner_join(CCLE.df,CCLE_samples,by="CCLE.name")

ggplot(CCLE.df.samples, aes(Order,PC1)) +
  geom_point(aes(colour=factor(Site.Primary))) + ylab("PC1")
```

In this case the figure is slightly confusing due to the number of factors. We can however rename factors that appear less than 30 times in total as "Other".

```{r}
rare.sites <- names(which(summary(CCLE.df.samples$Site.Primary) < 15))
CCLE.df.samples$Site.Primary2 <- as.character(CCLE.df.samples$Site.Primary)

rare.sites.loc <- which(CCLE.df.samples$Site.Primary2 %in% rare.sites)
CCLE.df.samples$Site.Primary2[rare.sites.loc] <- "Other"

ggplot(CCLE.df.samples, aes(Order,PC1)) +
  geom_point(aes(colour=factor(Site.Primary2))) + ylab("PC1")
```


```{r, warning=FALSE,message=FALSE }
ggplot(CCLE.df.samples, aes(Order,PC1)) +
  geom_point(aes(colour=factor(Gender))) + ylab("PC1")
```

Since in this case the data is categorical, it can be tested for significance using Pearson's chi squared test.

```{r}
library(MASS)

# create contingency tables
ctable.site <- table(CCLE.df.samples$Fork,
                     CCLE.df.samples$Site.Primary)

ctable.gender <- table(CCLE.df.samples$Fork,
                       CCLE.df.samples$Gender,
                       exclude = "U")

chisq.test(ctable.site)
chisq.test(ctable.gender)
```

As was easily apparent from examining the plots, the primary site the cell line is derived from is highly significant, while gender is not.


# Dealing with multiple runs

`MCbiclust` is a stochastic method so for best results it needs to be run multiple times, in practice this means using high-performance computing the run the algorithm on a computer cluster which will be dealt with in a later section. Here however the task of dealing with the results will be looked at. The algorithm will be run $100$ times with only $500$ iterations each. Typically more iterations are required, but for this demonstration it will be sufficient.

```{r, results='hide', message=FALSE, eval=FALSE}
CCLE.multi.seed <- list()
initial.seed1 <- list()

for(i in seq(100)){
  set.seed(i)
  initial.seed1[[i]] <- sample(seq(length = dim(CCLE_small)[2]),10)
  CCLE.multi.seed[[i]] <- FindSeed(gem = CCLE_small[c(501:1000), ],
                                   seed.size = 10,
                                   iterations = 500,
                                   initial.seed = initial.seed1[[i]])
}
```

```{r, results='hide', eval=TRUE, echo=FALSE}
CCLE.multi.seed <- MCbiclust:::Vignette_multi_seed
initial.seed1 <- MCbiclust:::Vignette_initial_seed
```

The associated correlation vector must also be calculated for each run and these correlation vectors can be put into a matrix.

```{r, results='hide', message=FALSE, eval=FALSE}
CCLE.cor.vec.multi <- list()

for(i in seq(100)){
  CCLE.cor.vec.multi[[i]] <- CVEval(gem.part = CCLE_small[c(501:1000), ],
                                    gem.all = CCLE_small,
                                    seed = CCLE.multi.seed[[i]],
                                    splits = 10)
                                      
}
```

```{r, results='hide', eval=TRUE, echo=FALSE}
CCLE.cor.vec.multi <- MCbiclust:::Vignette_multi_cv
```

```{r}
len.a <- length(CCLE.cor.vec.multi[[1]])
len.b <- length(CCLE.cor.vec.multi)
multi.run.cor.vec.mat <- matrix(0,len.a,len.b)
for(i in 1:100){
  multi.run.cor.vec.mat[,i] <- CCLE.cor.vec.multi[[i]]
}
rm(CCLE.cor.vec.multi)

```

A correlation matrix can be formed from the correlation vectors, and in this way they can be viewed as a heatmap.

```{r,dev='png'}
CV.cor.mat1 <- abs(cor((multi.run.cor.vec.mat)))
cor.dist <- function(c){as.dist(1 - abs(c))}

routput.corvec.matrix.cor.heat <- heatmap.2(CV.cor.mat1,
                                            trace="none",
                                            distfun = cor.dist)
```

It needs to be known how many distinct patterns have been found, this is done with clustering and particular silhouette coefficients to judge what number of clusters is optimum within the data. Function `SilhouetteClustGroups` achieves this and uses hierarchical clustering to split the patterns into clusters, for comparison a randomly generated correlation vector is also added to allow for the possibility that all patterns found are best grouped into a single cluster.

```{r}
multi.clust.groups <- SilhouetteClustGroups(multi.run.cor.vec.mat,
                                            max.clusters = 20,
                                            plots = TRUE,rand.vec = FALSE)
```

Here two clusters were found, and we can visualise this pattern (and any additional others found) with the function `CVPlot`, which highlights a chosen gene set, in this case the mitochondrial genes.

```{r,dev='png'}
gene.names <- row.names(CCLE_small)
av.corvec.fun <- function(x) rowMeans(multi.run.cor.vec.mat[,x])
average.corvec <- lapply(X = multi.clust.groups,
                         FUN = av.corvec.fun)

CVPlot(cv.df = as.data.frame(average.corvec),
        geneset.loc = mito.loc,
        geneset.name = "Mitochondrial",
        alpha1 = 0.1)
```

As before can also calculate the gene set enrichment.

```{r}
GOfun <- function(x) GOEnrichmentAnalysis(gene.names = gene.names,
                                          gene.values = x,
                                          sig.rate = 0.05)
```

```{r, results='hide', message=FALSE, eval=FALSE}
corvec.gsea <- lapply(X = average.corvec,
                      FUN = GOfun)
```

```{r, results='hide', eval=TRUE, echo=FALSE}
corvec.gsea <- MCbiclust:::Vignette_multi_gsea
```

Before using `SampleSort` a special prep function, `MultiSampleSortPrep` is used to generate the gene expression matrix and top seed for each found bicluster. The gene expression matrix is composed of the top $n$ genes in the correlation vector, and the seed is chosen as the calculated seed that has the maximum correlation score. 

```{r}
CCLE.samp.multi.sort <- list()
multi.prep <- MultiSampleSortPrep(gem = CCLE_small,
                                  av.corvec = average.corvec,
                                  top.genes.num = 750,
                                  groups = multi.clust.groups,
                                  initial.seeds =  CCLE.multi.seed)

```

```{r,eval=FALSE}
CCLE.samp.multi.sort[[1]] <- SampleSort(gem = multi.prep[[1]][[1]],
                                        seed = multi.prep[[2]][[1]])

CCLE.samp.multi.sort[[2]] <- SampleSort(gem = multi.prep[[1]][[2]],
                                        seed = multi.prep[[2]][[2]])     
```

Note as before that these are long calculations.

```{r, results='hide', echo=FALSE}
CCLE.samp.multi.sort <- list()
CCLE.samp.multi.sort[[1]] <- MCbiclust:::Vignette_sort[[2]][[1]]
CCLE.samp.multi.sort[[2]] <- MCbiclust:::Vignette_sort[[2]][[2]]
```

These two biclusters can now be analysed in the same way as the single bicluster before.


To calculate the PC1 values:

```{r}
pc1.vec.multi <- list()
 
pc1.vec.multi[[1]] <- PC1VecFun(top.gem =  multi.prep[[1]][[1]],
                     seed.sort = CCLE.samp.multi.sort[[1]], n = 10)
pc1.vec.multi[[2]] <- PC1VecFun(top.gem =  multi.prep[[1]][[2]],
                     seed.sort = CCLE.samp.multi.sort[[2]], n = 10)
```

These new biclusters can also be thresholded as follows:

```{r}
CCLE.bic.multi <- list()
CCLE.bic.multi[[1]] <- ThresholdBic(cor.vec = average.corvec[[1]],
                         sort.order = CCLE.samp.multi.sort[[1]],
                         pc1 = pc1.vec.multi[[1]], samp.sig = 0.05)
CCLE.bic.multi[[2]] <- ThresholdBic(cor.vec = average.corvec[[2]],
                         sort.order = CCLE.samp.multi.sort[[2]],
                         pc1 = pc1.vec.multi[[2]], samp.sig = 0.05)


pc1.vec.multi[[1]] <- PC1Align(gem = CCLE_small, pc1 = pc1.vec.multi[[1]],
                    sort.order = CCLE.samp.multi.sort[[1]],
                    cor.vec = average.corvec[[1]], bic = CCLE.bic.multi[[1]])

pc1.vec.multi[[2]] <- PC1Align(gem = CCLE_small, pc1 = pc1.vec.multi[[2]],
                    sort.order = CCLE.samp.multi.sort[[2]],
                    cor.vec = average.corvec[[2]], bic = CCLE.bic.multi[[2]])
```

In a similar way to before the forks for these new biclusters can be plotted:

```{r}
CCLE.multi.df <- data.frame(CCLE.name = colnames(CCLE_small),
           Bic1.order = order(CCLE.samp.multi.sort[[1]]),
           Bic2.order = order(CCLE.samp.multi.sort[[2]]),
           Bic1.PC1 = pc1.vec.multi[[1]][order(CCLE.samp.multi.sort[[1]])],
           Bic2.PC1 = pc1.vec.multi[[2]][order(CCLE.samp.multi.sort[[2]])])

CCLE.multi.df.samples <- inner_join(CCLE.multi.df,CCLE_samples,by="CCLE.name")

rare.sites <- names(which(summary(CCLE.multi.df.samples$Site.Primary) < 15))
CCLE.multi.df.samples$Site.Primary2 <- as.character(CCLE.multi.df.samples$Site.Primary)

rare.sites.loc <- which(CCLE.multi.df.samples$Site.Primary2 %in% rare.sites)
CCLE.multi.df.samples $Site.Primary2[rare.sites.loc] <- "Other"

ggplot(CCLE.multi.df.samples, aes(Bic1.order,Bic1.PC1)) +
  geom_point(aes(colour=factor(Site.Primary2))) + ylab("Bic1 PC1")

ggplot(CCLE.multi.df.samples, aes(Bic2.order,Bic2.PC1)) +
  geom_point(aes(colour=factor(Site.Primary2))) + ylab("Bic2 PC1")

```


One final thing that can be done is to compare all 3 correlation vectors found

```{r, dev="png"}
cv.df <- as.data.frame(average.corvec)
cv.df$Mito1 <- CCLE.cor.vec

CVPlot(cv.df,cnames = c("R1","R2","M1"),
        geneset.loc = mito.loc,
        geneset.name = "Mitochondrial",
        alpha1 = 0.1)

```

It is immediately apparent that the one of the biclusters found from the random gene set is very similar to that of the mitochondrial based bicluster.

# Identifying samples related to a known bicluster in different data sets

Once a bicluster has been identified it might be desired to find samples that have the same regulation pattern in different data sets. One option would be to run MCbiclust independently on these data sets and attempt to find a similar bicluster based on the correlation vector values. This however is not always practical, for example if the data set in question contains relatively few samples. 

There are however a few possible methods to score samples based on a known correlation pattern which are described here.

## PointScore

The PointScore can be calculated using the CCLE.mito data set as follow, this utilises the differently regulated group uncovered with `HclustGenesHiCor` and the dendrogram produced from using `heatmap.2`.

```{r}
gene.loc1 <- which(row.names(CCLE.mito[CCLE.hicor.genes,]) %in% CCLE.groups[[1]])
gene.loc2 <- which(row.names(CCLE.mito[CCLE.hicor.genes,]) %in% CCLE.groups[[2]])

CCLE.ps <- PointScoreCalc(CCLE.mito[CCLE.hicor.genes,], gene.loc1, gene.loc2)
```

The PointScore can be directly compared with the PC1 values

```{r, dev="png"}
CCLE.df$PointScore <- CCLE.ps[CCLE.samp.sort]

ggplot(CCLE.df, aes(Order,PC1)) +
  geom_point(aes(colour = Fork)) + ylab("PC1")
ggplot(CCLE.df, aes(Order,PointScore)) +
  geom_point(aes(colour = Fork)) + ylab("PointScore")

```


## ssGSEA

For single samples an alternative method must be used. One described in literature is that of single sample GSEA or ssGSEA (@barbie2009systematic). This can be calculated with the R package `GSVA` (@hanzelmann2013gsva), the ssGSEA score of the two gene sets can be calculated, the final ssGSEA of these two groups combines is the mean of the first group and the negative value of the second group.

```{r}
# library(GSVA)
# 
# ssGSEA.test <- gsva(expr = as.matrix(CCLE.mito[CCLE.hicor.genes,]),
#                     gset.idx.list = CCLE.groups,
#                     method = 'gsva',
#                     parallel.sz = 1)
# ssGSEA.test[2,] <- -ssGSEA.test[2,]
# CCLE.ssGSEA <- colMeans(ssGSEA.test)

```

Similarly to the PointScore it can be directly compared to the PC1 values.

```{r, dev="png"}
# CCLE.df$ssGSEA <- CCLE.ssGSEA[CCLE.samp.sort]
# 
# ggplot(CCLE.df, aes(Order, PC1)) +
#   geom_point(aes(colour = Fork)) + ylab("PC1")
# ggplot(CCLE.df, aes(Order, ssGSEA)) +
#   geom_point(aes(colour = Fork)) + ylab("ssGSEA")

```

Note that while the PointScore created a very clean fork, the ssGSEA was much noisier. In general the bigger the data set the more accurate the PointScore will be, while ssGSEA is useful for analysing very small datasets or even single samples.

# Session Info {-}

```{r session_info, include=TRUE, echo=TRUE, results='markup'}
devtools::session_info()
```

# References {-}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GOEnrichmentAnalysis.R
\name{GOEnrichmentAnalysis}
\alias{GOEnrichmentAnalysis}
\alias{GOEnrichmentAnalysis}
\title{Calculate gene set enrichment of correlation vector using Mann-Whitney test}
\usage{
GOEnrichmentAnalysis(gene.names, gene.values, sig.rate)
}
\arguments{
\item{gene.names}{Names of the genes in standard gene name format.}

\item{gene.values}{Values associated with the genes, e.g the correlation vector
output of \code{CVEval}.}

\item{sig.rate}{Level of significance required after multiple hypothesis
adjustment.}
}
\value{
Data frame of the significant gene sets, with GOID, GO Term, number
 of genes, number of genes in GO Term, number of genes in GO Term also in
 gene set, adjusted p-value, average value of correlation vector in gene set
 and phenotype describing whether average value of correlation vector is
 above or below the total average.
}
\description{
The Mann-Whitney test is typically used due to the values of the correlation
 vector, not being normally distributed. \code{GOEnrichmentAnalysis} provides 
 an interface  with the GO database annotation to find the most significant GO
 terms.
}
\examples{
data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- (row.names(CCLE_small) \%in\% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

set.seed(101)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 100)

CCLE.cor.vec <- CVEval(gem.part = CCLE.mito,
                       gem.all = CCLE_small,
                       seed = CCLE.seed, splits = 10)

# Significant GO terms can be calculated as follows:
# GEA <- GOEnrichmentAnalysis(gene.names = row.names(CCLE_small),
#                            gene.values = CCLE.cor.vec,
#                            sig.rate = 0.05)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SampleSort.R
\name{SampleSort}
\alias{SampleSort}
\alias{SampleSort}
\alias{MultiSampleSortPrep}
\title{Methods for ordering samples}
\usage{
SampleSort(gem, seed, num.cores = 1, sort.length = NULL)

MultiSampleSortPrep(gem, av.corvec, top.genes.num, groups, initial.seeds)
}
\arguments{
\item{gem}{Gene expression matrix with genes as rows and samples as columns}

\item{seed}{Sample seed of highly correlating genes}

\item{num.cores}{Number of cores used in parallel evaluation}

\item{sort.length}{Number of samples to be sorted}

\item{av.corvec}{List of average correlation vector}

\item{top.genes.num}{Number of the top genes in correlation vector to use for sorting samples}

\item{groups}{List showing what runs belong to which correlation vector group}

\item{initial.seeds}{List of sample seeds from all runs}
}
\value{
Order of samples by strength to correlation pattern
}
\description{
After finding an initial bicluster with \code{FindSeed()} the next step is
to extend the bicluster by ordering the remaining samples by how they 
preserve the correlation found.
}
\details{
\code{SampleSort()} is the basic function that achieves this, it takes the
gene expression matrix, seed of samples, and also has options for the number
of cores to run the method on and the number of samples to sort.

\code{MultiSampleSortPrep()} is a preparation function for \code{SampleSort()}
when MCbiclust has been run multiple times and returns a list of gene expression
matrices and seeds for each `distinct` bicluster found.
}
\examples{
data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- (row.names(CCLE_small) \%in\% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

set.seed(102)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 1000)

CCLE.sort <- SampleSort(gem = CCLE.mito,seed = CCLE.seed,sort.length = 11)

# Full ordering are in Vignette_sort in sysdata.rda
CCLE.samp.sort <- MCbiclust:::Vignette_sort[[1]]

CCLE.pc1 <- PC1VecFun(top.gem = CCLE.mito,
                      seed.sort = CCLE.samp.sort,
                      n = 10)

CCLE.cor.vec <-  CVEval(gem.part = CCLE.mito,
                            gem.all = CCLE_small,
                            seed = CCLE.seed,
                            splits = 10)

CCLE.bic <- ThresholdBic(cor.vec = CCLE.cor.vec,sort.order = CCLE.samp.sort,
                         pc1 = as.numeric(CCLE.pc1))

CCLE.pc1 <- PC1Align(gem = CCLE_small, pc1 = CCLE.pc1,
                     cor.vec = CCLE.cor.vec ,
                     sort.order = CCLE.samp.sort,
                     bic =CCLE.bic)

CCLE.fork <- ForkClassifier(CCLE.pc1, samp.num = length(CCLE.bic[[2]]))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{Mitochondrial_genes}
\alias{Mitochondrial_genes}
\title{List of known mitochondrial genes}
\format{A Character vector of the HGNC approved gene names}
\source{
\url{https://www.broadinstitute.org/publications/broad807s}
}
\usage{
Mitochondrial_genes
}
\value{
NA
}
\description{
A dataset from MitoCarta1.0 containing the 1023 mitochondrial genes
Availiable from the broad institute: http://www.broadinstitute.org/scientific-community/science/programs/metabolic-disease-program/publications/mitocarta/mitocarta-in-0
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CVEval.R
\name{CVEval}
\alias{CVEval}
\alias{CVEval}
\title{Method for the calculation of a correlation vector}
\usage{
CVEval(gem.part, gem.all, seed, splits)
}
\arguments{
\item{gem.part}{Part of gene expression matrix only containing gene set of interest with genes as rows and samples as columns}

\item{gem.all}{All of gene expression matrix}

\item{seed}{Seed of highly correlating samples}

\item{splits}{Number of cuts from hierarchical clustering}
}
\value{
Correlation vector
}
\description{
Upon identifying a bicluster seed with \code{FindSeed}, one of the next
steps is to identify which genes not in your chosen gene set are also
highly correlated to the bicluster found. This is done by \code{CVEval},
and the output is known as the correlation vector.
}
\details{
\code{CVeval} uses hierarchical clustering to select the genes most 
representative of the bicluster and then uses the average expression of
these genes across the sample seed and calculates the correlation of
every gene measured across the sample seed to this average expression value.

The correlation vector is the output of this calculation.
}
\examples{
data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- (row.names(CCLE_small) \%in\% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

set.seed(102)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 1000)

CCLE.sort <- SampleSort(gem = CCLE.mito,seed = CCLE.seed,sort.length = 11)

# Full ordering are in Vignette_sort in sysdata.rda
CCLE.samp.sort <- MCbiclust:::Vignette_sort[[1]]

CCLE.pc1 <- PC1VecFun(top.gem = CCLE.mito,
                      seed.sort = CCLE.samp.sort,
                      n = 10)

CCLE.cor.vec <-  CVEval(gem.part = CCLE.mito,
                            gem.all = CCLE_small,
                            seed = CCLE.seed,
                            splits = 10)

CCLE.bic <- ThresholdBic(cor.vec = CCLE.cor.vec,sort.order = CCLE.samp.sort,
                         pc1 = as.numeric(CCLE.pc1))

CCLE.pc1 <- PC1Align(gem = CCLE_small, pc1 = CCLE.pc1,
                     cor.vec = CCLE.cor.vec ,
                     sort.order = CCLE.samp.sort,
                     bic =CCLE.bic)

CCLE.fork <- ForkClassifier(CCLE.pc1, samp.num = length(CCLE.bic[[2]]))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{CCLE_samples}
\alias{CCLE_samples}
\title{Clinical information for CCLE data}
\format{A data frame with 967 rows and 14 variables:
\itemize{
  \item CCLE.name: Sample name identifier.
  \item Cell.line.primary.name: Cell line name.
  \item Cell.line.aliases: Any known aliases of cell line.
  \item Gender: Gender of patient cell line derived from.
  \item Site.Primary: Primary site cell line derived from.
  \item Histology: Histology of tumour cell line derived from.
  \item Hist.Subtype1: Histology subtype of tumour cell line derived from.
  \item Notes: Additional notes.
  \item Source: Source of the cell line.
  \item Expression.arrays: Expression array used.
  \item SNP.arrays: SNP array used.
  \item Oncomap: Oncomap mutation array used.
  \item Hybrid.Capture.Sequencing: Hybrid capture sequencing used.
  \item Name: Sample name identifier
}}
\source{
\url{http://www.broadinstitute.org/ccle/data/browseData} Filename: CCLE_sample_info_file_2012-04-06.txt
}
\usage{
CCLE_samples
}
\value{
NA
}
\description{
A dataset containing clinical information for the CCLE samples.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FindSeed.R
\name{FindSeed}
\alias{FindSeed}
\title{Find highly correlated seed of samples for gene expression matrix}
\usage{
FindSeed(gem, seed.size, iterations, initial.seed = NULL, messages = 100)
}
\arguments{
\item{gem}{Gene expression matrix with genes as rows and samples as columns}

\item{seed.size}{Size of sample seed}

\item{iterations}{Number of iterations}

\item{initial.seed}{Initial seed used, if NULL randomly chosen}

\item{messages}{frequency of progress messages}
}
\value{
Highly correlated seed
}
\description{
\code{FindSeed()} is the key function in MCbiclust. It takes a gene expression
matrix and by a stochastic method greedily searches for a seed of samples
that maximizes the correlation score of the chosen gene set.
}
\details{
Additional options allow for the search to start at a chosen seed, for instance
if a improvement to a known seed is desired. The result of \code{FindSeed()} is 
dependent on the number of iterations, with above 1000 usually providing a good
seed, and above 10000 an optimum seed.
}
\examples{
data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- which(row.names(CCLE_small) \%in\% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

random.seed <- sample(seq(length = dim(CCLE.mito)[2]),10)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 100)


CorScoreCalc(CCLE.mito, random.seed)
CorScoreCalc(CCLE.mito, CCLE.seed)

CCLE.hicor.genes <- as.numeric(HclustGenesHiCor(CCLE.mito,
                                                CCLE.seed,
                                                cuts = 8))

CorScoreCalc(CCLE.mito[CCLE.hicor.genes,], CCLE.seed)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{CCLE_small}
\alias{CCLE_small}
\title{Subset of expression levels of CCLE data}
\format{A data frame with 1000 rows and 500 variables:
\itemize{
  \item MKN74_STOMACH: mRNA expression on sample MKN74_STOMACH
  \item OC316_OVARY: mRNA expressionr on sample OC316_OVARY
  \item ...
}
 @source \url{http://www.broadinstitute.org/ccle/data/browseData} Filename: CCLE_Expression_Entrez_2012-04-06.gct.gz}
\usage{
CCLE_small
}
\value{
NA
}
\description{
A dataset containing the gene-centric RMA-normalized mRNA expression data for nearly 1000 genes and 500 samples taken as a random subset of the complete CCLE data. 
1000 genes were selected randomly such that 500 were mitochondrial and 500 non-mitochondrial.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PC1VecFun.R
\name{PC1VecFun}
\alias{PC1VecFun}
\title{Calculate PC1 vector of found pattern}
\usage{
PC1VecFun(top.gem, seed.sort, n)
}
\arguments{
\item{top.gem}{Gene expression matrix containing only highly correlating genes}

\item{seed.sort}{Ordering of samples according to strength of correlation}

\item{n}{Number of samples to use in calculation of PC1}
}
\value{
PC1 value for each sample
}
\description{
The correlations found between the chosen geneset in a subset of samples
can be summarised by looking at the first principal component (PC1) 
using principal coponent analysis (PCA).
}
\details{
\code{PC1VecFun()} takes a gene expression matrix and the sample ordering
and fits a PC1 value to all the samples based on a PCA analysis done on
the first n samples.
}
\examples{
data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- (row.names(CCLE_small) \%in\% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

set.seed(102)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 1000)

CCLE.sort <- SampleSort(gem = CCLE.mito,seed = CCLE.seed,sort.length = 11)

# Full ordering are in Vignette_sort in sysdata.rda
CCLE.samp.sort <- MCbiclust:::Vignette_sort[[1]]

CCLE.pc1 <- PC1VecFun(top.gem = CCLE.mito,
                      seed.sort = CCLE.samp.sort,
                      n = 10)

CCLE.cor.vec <-  CVEval(gem.part = CCLE.mito,
                            gem.all = CCLE_small,
                            seed = CCLE.seed,
                            splits = 10)

CCLE.bic <- ThresholdBic(cor.vec = CCLE.cor.vec,sort.order = CCLE.samp.sort,
                         pc1 = as.numeric(CCLE.pc1))

CCLE.pc1 <- PC1Align(gem = CCLE_small, pc1 = CCLE.pc1,
                     cor.vec = CCLE.cor.vec ,
                     sort.order = CCLE.samp.sort,
                     bic =CCLE.bic)

CCLE.fork <- ForkClassifier(CCLE.pc1, samp.num = length(CCLE.bic[[2]]))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MCbiclust.R
\docType{package}
\name{MCbiclust}
\alias{MCbiclust}
\alias{MCbiclust-package}
\title{MCbiclust: Massively Correlated biclustering}
\description{
MCbiclust is a R package for running massively correlating biclustering
analysis.MCbiclust aims to find large scale biclusters with selected 
features being highly correlated with each other over a subset of samples.
}
\details{
The package was originally designed in order to solve a problem in
bioinformatics: to find biclusters representing different modes of regulation
of mitochondria gene expression in disease states such as breast cancer. 
The same methods however, can be used on any gene expression data set to
find biclusters of interest.

To learn more about MCbiclust, start with the vignette:
\code{browseVignettes(package = "MCbiclust")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CorScoreCalc.r
\name{CorScoreCalc}
\alias{CorScoreCalc}
\title{Calculate correlation score}
\usage{
CorScoreCalc(gene.expr.matrix, sample.vec)
}
\arguments{
\item{gene.expr.matrix}{Gene expression matrix with genes as rows and samples as columns}

\item{sample.vec}{Vector of samples}
}
\value{
The correlation score
}
\description{
The standard method to calculate the correlation score used to judge biclusters
in MCbiclust
}
\examples{
data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- which(row.names(CCLE_small) \%in\% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

random.seed <- sample(seq(length = dim(CCLE.mito)[2]),10)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 100)


CorScoreCalc(CCLE.mito, random.seed)
CorScoreCalc(CCLE.mito, CCLE.seed)

CCLE.hicor.genes <- as.numeric(HclustGenesHiCor(CCLE.mito,
                                                CCLE.seed,
                                                cuts = 8))

CorScoreCalc(CCLE.mito[CCLE.hicor.genes,], CCLE.seed)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CVPlot.R
\name{CVPlot}
\alias{CVPlot}
\title{Make correlation vector plot}
\usage{
CVPlot(cv.df, geneset.loc, geneset.name, alpha1 = 0.005, alpha2 = 0.1,
  cnames = NULL)
}
\arguments{
\item{cv.df}{A dataframe containing the correlation vectors of one or more patterns.}

\item{geneset.loc}{A gene set of interest (e.g. mitochondrial) to be plotted separately from rest of genes.}

\item{geneset.name}{Name of geneset (e.g. mitochondrial genes)}

\item{alpha1}{Transparency level of non-gene set genes}

\item{alpha2}{Transparency level of gene set genes}

\item{cnames}{Character vector containing names for the correlation vector}
}
\value{
A plot of the correlation vectors
}
\description{
A function to visualise the differences between different found biclusters. 
Output is a matrix of plots. Each correlation vector is plotted against each 
other across the entire  measured gene set in the lower diagonal plots, and
a chosen gene set (e.g. mitochondrial) in the upper diagonal plots. The diagnal
plots themselves show the density plots of the entire measured and chosen
gene set. There are addition options to set the transparancy of the data
points and names of the correlation vectors.
}
\examples{
data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- which(row.names(CCLE_small) \%in\% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

CCLE.seed <- list()
CCLE.cor.vec <- list()

for(i in 1:3){
    set.seed(i)
    CCLE.seed[[i]] <- FindSeed(gem = CCLE.mito,
                               seed.size = 10,
                               iterations = 100,
                               messages = 100)}

for(i in 1:3){
    CCLE.cor.vec[[i]] <-  CVEval(gem.part = CCLE.mito,
                                 gem.all = CCLE_small,
                                 seed = CCLE.seed[[i]],
                                splits = 10)}



CCLE.cor.df <- (as.data.frame(CCLE.cor.vec))

CVPlot(cv.df = CCLE.cor.df, geneset.loc = mito.loc,
       geneset.name = "Mitochondrial",alpha1 = 0.5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PointScore.R
\name{PointScoreCalc}
\alias{PointScoreCalc}
\title{Calculate PointScore}
\usage{
PointScoreCalc(gene.expr.matrix, gene.loc1, gene.loc2)
}
\arguments{
\item{gene.expr.matrix}{Gene expression matrix with genes as rows and samples as columns}

\item{gene.loc1}{Location of the rows containing the genes in gene set 1 within the gene expression matrix}

\item{gene.loc2}{Location of the rows containing the genes in gene set 2 within the gene expression matrix}
}
\value{
Vector of point scores for each sample in the gene expression matrix
}
\description{
Using two gene sets that are represented of a known bicluster (one gene set being 
up regulated while other gene set is down regulated), samples are scored based
on how well they match the known regulation of the bicluster.
}
\details{
The PointScore of a sample can be directly compared to the PC1 value. The PointScore
is typically used to identify samples related to the upper/lower fork  of a bicluster
without running the complete main MCbiclust pipeline on a dataset.
}
\examples{
data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- (row.names(CCLE_small) \%in\% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

set.seed(102)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 1000)

CCLE.sort <- SampleSort(gem = CCLE.mito,seed = CCLE.seed,sort.length = 11)

# Full ordering are in Vignette_sort in sysdata.rda
CCLE.samp.sort <- MCbiclust:::Vignette_sort[[1]]

CCLE.pc1 <- PC1VecFun(top.gem = CCLE.mito,
                      seed.sort = CCLE.samp.sort,
                      n = 10)

CCLE.hicor.genes <- as.numeric(HclustGenesHiCor(CCLE.mito,
                                                CCLE.seed,
                                                cuts = 8))

CCLE.cor.mat <- cor(t(CCLE.mito[CCLE.hicor.genes,CCLE.seed]))

gene.set1 <- labels(as.dendrogram(hclust(dist(CCLE.cor.mat)))[[1]])
gene.set2 <- labels(as.dendrogram(hclust(dist(CCLE.cor.mat)))[[2]])

gene.set1.loc <- which(row.names(CCLE.mito) \%in\% gene.set1)
gene.set2.loc <- which(row.names(CCLE.mito) \%in\% gene.set2)

ps.vec <- PointScoreCalc(CCLE.mito,gene.set1.loc,gene.set2.loc)

cor(ps.vec[CCLE.samp.sort], CCLE.pc1)
plot(ps.vec[CCLE.samp.sort])
plot(CCLE.pc1)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HclustGenesHiCor.R
\name{HclustGenesHiCor}
\alias{HclustGenesHiCor}
\title{Find the most highly correlated genes using hierarchical clustering}
\usage{
HclustGenesHiCor(gem, seed, cuts)
}
\arguments{
\item{gem}{Gene expression matrix with genes as rows and samples as columns}

\item{seed}{Seed of highly correlating samples}

\item{cuts}{Number of groups to cut dendogram into}
}
\value{
Numeric vector of most highly correlated genes
}
\description{
Upon finding an initial bicluster with \code{FindSeed()} not all the genes
in the chosen geneset will be highly correlated to the bicluster. 
\code{HclustGenesHiCor()} uses the output of \code{FindSeed()} and 
hierarchical clustering to only select the genes that are most highly correlated
to the bicluster. This is achieved by cutting the dendogram produced
from the clustering into a set number of groups and then only selecting the
groups that are most highly correlated to the bicluster
}
\examples{
data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- which(row.names(CCLE_small) \%in\% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

random.seed <- sample(seq(length = dim(CCLE.mito)[2]),10)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 100)


CorScoreCalc(CCLE.mito, random.seed)
CorScoreCalc(CCLE.mito, CCLE.seed)

CCLE.hicor.genes <- as.numeric(HclustGenesHiCor(CCLE.mito,
                                                CCLE.seed,
                                                cuts = 8))

CorScoreCalc(CCLE.mito[CCLE.hicor.genes,], CCLE.seed)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ThresholdBic.R
\name{ThresholdBic}
\alias{ThresholdBic}
\alias{ThresholdBic}
\alias{PC1Align}
\alias{ForkClassifier}
\title{Methods for defining a bicluster}
\usage{
ThresholdBic(cor.vec, sort.order, pc1, samp.sig = 0)

PC1Align(gem, pc1, cor.vec, sort.order, bic)

ForkClassifier(pc1, samp.num)
}
\arguments{
\item{cor.vec}{Correlation vector (output of \code{CVEval()}).}

\item{sort.order}{Order of samples (output of \code{SampleSort()}).}

\item{pc1}{PC1 values for samples (output of \code{PC1VecFun}).}

\item{samp.sig}{Value between 0 and 1 determining number of samples in bicluster}

\item{gem}{Gene expression matrix containing genes as rows and samples as columns.}

\item{bic}{bicluster (output of \code{ThresholdBic()})}

\item{samp.num}{Number of samples in the bicluster}
}
\value{
Defined bicluster
}
\description{
A bicluster is the fundamental result found using MCbiclust. These
three functions are essential for the precise definition of these
biclusters.
}
\details{
\code{ThresholdBic()} takes as its main inputs the correlation vector 
(output of \code{CVEval()}), sample ordering (output of
\code{SampleSort()}), PC1 vector (output of \code{PC1VecFun}) and returns
a list of the genes and samples which belong to the bicluster according 
to a certain level of significance.

\code{PC1Align()} is a function used once the bicluster has been found to
ensure that the upper fork samples (those with higher PC1 values) correspond
to those samples that have genes with positive correlation vector values
up-regulated.

\code{ForkClassifier()} is a function used to classify which samples are in
the upper or lower fork.
}
\examples{
data(CCLE_small)
data(Mitochondrial_genes)

mito.loc <- (row.names(CCLE_small) \%in\% Mitochondrial_genes)
CCLE.mito <- CCLE_small[mito.loc,]

set.seed(102)
CCLE.seed <- FindSeed(gem = CCLE.mito,
                      seed.size = 10,
                      iterations = 100,
                      messages = 1000)

CCLE.sort <- SampleSort(gem = CCLE.mito,seed = CCLE.seed,sort.length = 11)

# Full ordering are in Vignette_sort in sysdata.rda
CCLE.samp.sort <- MCbiclust:::Vignette_sort[[1]]

CCLE.pc1 <- PC1VecFun(top.gem = CCLE.mito,
                      seed.sort = CCLE.samp.sort,
                      n = 10)

CCLE.cor.vec <-  CVEval(gem.part = CCLE.mito,
                            gem.all = CCLE_small,
                            seed = CCLE.seed,
                            splits = 10)

CCLE.bic <- ThresholdBic(cor.vec = CCLE.cor.vec,sort.order = CCLE.samp.sort,
                         pc1 = as.numeric(CCLE.pc1))

CCLE.pc1 <- PC1Align(gem = CCLE_small, pc1 = CCLE.pc1,
                     cor.vec = CCLE.cor.vec ,
                     sort.order = CCLE.samp.sort,
                     bic =CCLE.bic)

CCLE.fork <- ForkClassifier(CCLE.pc1, samp.num = length(CCLE.bic[[2]]))

}
